'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by Measurement Studio.
'     Runtime Version:2.0.50727.832
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------

Option Strict Off
Option Explicit On

Imports System
Imports System.Runtime.InteropServices

Namespace NationalInstruments.ModularInstruments.Interop

    Public Class niScope
        Inherits Object
        Implements System.IDisposable

        Private _handle As System.IntPtr

        Private _disposed As Boolean = True

        '''''<summary>
        '''''Performs the following initialization actions:
        '''''
        '''''- Creates a new IVI instrument driver session 
        '''''- Opens a session to the specific driver using the interface and address you specify in the resourceName parameter 
        '''''- Queries the instrument ID and checks that it is valid for this instrument driver, if the IDQuery parameter is set to NISCOPE_VAL_TRUE 
        '''''- Resets the digitizer to a known state, if the resetDevice parameter is set to NISCOPE_VAL_TRUE
        '''''- Sends initialization commands to set the instrument to the state necessary for the operation of the instrument driver 
        '''''- Returns an instrument handle that you use to identify the instrument in all subsequent instrument driver function calls
        '''''
        '''''</summary>
        '''''<param name="Resource_Name">
        '''''Specifies the resource name of the device to initialize.
        '''''
        '''''Example Device Type Syntax 
        '''''1 Traditional NI-DAQ device DAQ::1 (1 = device number)
        '''''2 NI-DAQmx device myDAQmxDevice (myDAQmxDevice = device name) 
        '''''3 NI-DAQmx device DAQ::myDAQmxDevice myDAQmxDevice = device name)
        '''''4 NI-DAQmx device DAQ::2 (2 = device name)
        '''''5 IVI logical name or IVI virtual name myLogicalName          (myLogicalName = name)
        '''''
        '''''
        '''''For Traditional NI-DAQ devices, the syntax is DAQ::n, where n is the device number assigned by MAX, as shown in Example 1. 
        '''''
        '''''For NI-DAQmx devices, the syntax is just the device name specified in MAX, as shown in Example 2. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot1. You can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new name. 
        '''''
        '''''An alternative syntax for NI-DAQmx devices consists of DAQ::NI-DAQmx device name, as shown in Example 3. This naming convention allows for the use of an NI-DAQmx device in an application that was originally designed for a Traditional NI-DAQ device. For example, if the application expects DAQ::1, you can rename the NI-DAQmx device to 1 in MAX and pass in DAQ::1 for the resource name, as shown in Example 4. 
        '''''
        '''''If you use the DAQ::n syntax and an NI-DAQmx device name already exists with that same name, the NI-DAQmx device is matched first. 
        '''''
        '''''You can also pass in the name of an IVI logical name or an IVI virtual name configured with the IVI Configuration utility, as shown in Example 5. A logical name identifies a particular virtual instrument. A virtual name identifies a specific device and specifies the initial settings for the session. 
        '''''
        ''''' Caution  Traditional NI-DAQ and NI-DAQmx device names are not case-sensitive. However, all IVI names, such as logical names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must make sure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters.  
        '''''
        '''''</param>
        '''''<param name="ID_Query">
        '''''Specifies whether you want the instrument driver to perform an ID Query. When you set this parameter to TRUE, NI-SCOPE verifies that the instrument you initialize is a type that this driver supports. 
        ''''' 
        '''''Defined Values
        '''''
        '''''VI_TRUE (1)-- Perform ID Query 
        '''''
        '''''VI_FALSE (0)-- Skip ID Query
        '''''
        '''''
        '''''</param>
        '''''<param name="Reset_Device">
        '''''Specifies whether to reset the instrument during the initialization process. 
        '''''
        '''''Defined Values
        '''''
        '''''VI_TRUE (1)- Reset device
        '''''
        '''''VI_FALSE (0)- Do not reset device
        '''''
        '''''Default Value: VI_TRUE (1)
        '''''
        '''''
        '''''
        '''''</param>
        '''''<param name="Instrument_Handle">
        '''''Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls.
        '''''</param>
        Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean)
            MyBase.New()
            Dim pInvokeResult As Integer = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Me._disposed = False
        End Sub

        '''''<summary>
        '''''Performs the following initialization actions:
        '''''
        '''''- Creates a new IVI instrument driver and optionally sets the initial state of the following session properties: Range Check, Cache, Simulate, Record Value Coercions 
        '''''- Opens a session to the specified device using the interface and address you specify for the Resource Name parameter 
        '''''- Resets the digitizer to a known state if the resetDevice parameter is set to VI_TRUE
        '''''- Queries the instrument ID and verifies that it is valid for this instrument driver if the IDQuery parameter is set to VI_TRUE 
        '''''- Returns an instrument handle that you use to identify the instrument in all subsequent instrument driver function calls 
        '''''
        '''''
        '''''
        '''''
        '''''</summary>
        '''''<param name="Resource_Name">
        '''''Specifies the resource name of the device to initialize.
        '''''
        '''''Example Device Type Syntax 
        '''''1 Traditional NI-DAQ device DAQ::1 (1 = device number)
        '''''2 NI-DAQmx device myDAQmxDevice (myDAQmxDevice = device name) 
        '''''3 NI-DAQmx device DAQ::myDAQmxDevice myDAQmxDevice = device name)
        '''''4 NI-DAQmx device DAQ::2 (2 = device name)
        '''''5 IVI logical name or IVI virtual name myLogicalName          (myLogicalName = name)
        '''''
        '''''For Traditional NI-DAQ devices, the syntax is DAQ::n, where n is the device number assigned by MAX, as shown in Example 1. 
        '''''
        '''''For NI-DAQmx devices, the syntax is just the device name specified in MAX, as shown in Example 2. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot1. You can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new name. 
        '''''
        '''''An alternatative syntax for NI-DAQmx devices consists of DAQ::NI-DAQmx device name, as shown in Example 3. This naming convention allows for the use of an NI-DAQmx device in an application that was originally designed for a Traditional NI-DAQ device. For example, if the application expects DAQ::1, you can rename the NI-DAQmx device to 1 in MAX and pass in DAQ::1 for the resource name, as shown in Example 4. 
        '''''
        '''''If you use the DAQ::n syntax and an NI-DAQmx device name already exists with that same name, the NI-DAQmx device is matched first. 
        '''''
        '''''You can also pass in the name of an IVI logical name or an IVI virtual name configured with the IVI Configuration utility, as shown in Example 5. A logical name identifies a particular virtual instrument. A virtual name identifies a specific device and specifies the initial settings for the session. 
        '''''
        ''''' Caution  Traditional NI-DAQ and NI-DAQmx device names are not case-sensitive. However, all IVI names, such as logical names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must make sure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters.  
        '''''
        '''''</param>
        '''''<param name="ID_Query">
        '''''Specifies whether you want the instrument driver to perform an ID Query.
        '''''Valid Values
        '''''
        '''''VI_TRUE (1)- Perform ID Query 
        '''''
        '''''VI_FALSE (0)- Skip ID Query
        '''''
        '''''Default Value: VI_FALSE
        '''''
        '''''When you set this parameter to NISCOPE_VAL_TRUE, NI-SCOPE verifies that the instrument you initialize is a type that this driver supports.
        '''''
        '''''</param>
        '''''<param name="Reset_Device">
        '''''Specifies whether you want the to reset the digitizer to a known state during the initialization procedure.
        '''''
        '''''Valid Range:
        '''''NISCOPE_VAL_TRUE  (1) - Reset Scope
        '''''NISCOPE_VAL_FALSE (0) - Don't Reset Scope
        '''''
        '''''Default Value:
        '''''NISCOPE_VAL_TRUE (1)
        '''''
        '''''</param>
        '''''<param name="Option_String">
        '''''Specifies initialization commands. The following table lists the attributes and the name you use in the option string parameter to identify the attribute.
        '''''
        '''''Attribute Name Attribute Values 
        '''''RangeCheck - NISCOPE_ATTR_RANGE_CHECK VI_TRUE, VI_FALSE 
        '''''QueryInstrStatus - NISCOPE_QUERY_INSTRUMENT_STATUS VI_TRUE, VI_FALSE  
        '''''Cache - NISCOPE_ATTR_CACHE VI_TRUE, VI_FALSE 
        '''''Simulate - NISCOPE_ATTR_SIMULATE VI_TRUE, VI_FALSE  
        '''''
        '''''Default Values: "Simulate=0,RangeCheck=1,QueryInstrStatus=1,Cache=1"
        '''''
        '''''You can use the option string to simulate a device. The DriverSetup flag specifies the model that is to be simulated and the type of the model. One example to simulate an NI PXI-5102 would be as follows:
        '''''
        '''''Option String: Simulate = 1, DriverSetup = Model:5102; BoardType:PXI
        '''''
        '''''Refer to the example niScope EX Simulated Acquisition for more information on simulation.
        '''''
        ''''' Caution  All IVI names, such as logical names or virtual names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must make sure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters in the name.  
        '''''
        '''''Default Value: "Simulate=0,RangeCheck=1,Cache=1"
        '''''
        '''''
        '''''</param>
        '''''<param name="Instrument_Handle">
        '''''Returns a ViSession handle that you use to identify the instrument in all subsequent instrument driver function calls.
        '''''</param>
        Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean, ByVal Option_String As String)
            MyBase.New()
            Dim pInvokeResult As Integer = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Option_String, Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Me._disposed = False
        End Sub

        '''''<summary>
        '''''Automatically configures the instrument. When you call this function, the digitizer senses the input signal and automatically configures many of the instrument settings. If no signal is found on any analog input channel, a warning is returned, and all channels are enabled. A channel is considered to have a signal present if the signal is at least 10% of the smallest vertical range available for that channel. 
        '''''
        '''''
        '''''The following settings are changed:
        '''''
        '''''General
        '''''Acquisition mode      Normal
        '''''Reference Clock       Internal
        '''''
        '''''Vertical
        '''''Vertical Coupling     AC ((DC for NI 5620/5621)
        '''''Vertical Bandwidth    Full
        '''''Vertical Range        Changed by Auto Setup
        '''''Vertical Offset       0 V
        '''''Probe Attenuation     Unchanged by Auto Setup
        '''''Input Impedance       Unchanged by Auto Setup
        '''''
        '''''Horizontal
        '''''Sample Rate           Changed by Auto Setup
        '''''Min Record Length     Changed by Auto Setup
        '''''Enforce Realtime      True
        '''''Number of Records     Changed to 1
        '''''
        '''''Triggering
        '''''Trigger Mode          Edge if signal present, otherwise Immediate
        '''''Trigger Channel       Lowest numbered channel with a signal present
        '''''Trigger Slope         Positive
        '''''Trigger Coupling      DC
        '''''Reference Position    50%
        '''''Trigger Level         50% of signal on trigger channel
        '''''Trigger Delay         0
        '''''Trigger Holdoff       0
        '''''Trigger Output        None
        ''''' 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function AutoSetup() As Integer
            Dim pInvokeResult As Integer = PInvoke.AutoSetup(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures how the digitizer acquires data and fills the waveform record.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Acquisition_Type">
        '''''Specifies the manner in which the digitizer acquires data and fills the waveform record; NI-SCOPE sets the NISCOPE_ATTR_ACQUISITION_TYPE attribute to this value.
        '''''
        '''''Defined Values
        '''''
        '''''NISCOPE_VAL_NORMAL 
        '''''
        '''''NISCOPE_VAL_FLEXRES 
        '''''
        '''''NISCOPE_VAL_DDC
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureAcquisition(ByVal Acquisition_Type As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureAcquisition(Me._handle, Acquisition_Type)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the common properties of the horizontal subsystem for a multi-record acquisition in terms of minimum sample rate. 
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Min_Sample_Rate">
        '''''The sampling rate for the acquisition; NI-SCOPE uses this value to set  NISCOPE_ATTR_MIN_SAMPLE_RATE.
        '''''</param>
        '''''<param name="Min_Num_Pts">
        '''''The minimum number of points you need in the record for each channel; call niScope_ActualRecordLength to obtain the actual record length used.
        '''''
        '''''Valid Values 
        '''''Greater than 1; limited by available memory
        '''''
        '''''
        '''''</param>
        '''''<param name="Ref_Position">
        '''''The position of the Reference Event in the waveform record specified as a percentage.
        '''''</param>
        '''''<param name="Num_Records">
        '''''The number of records to acquire.
        '''''</param>
        '''''<param name="Enforce_Realtime">
        '''''Indicates whether the digitizer enforces real-time measurements or allows equivalent-time measurements.
        '''''
        '''''Default Value: NISCOPE_VAL_TRUE (1)
        '''''
        '''''Valid Range:
        '''''VI_TRUE (1) - Allow real-time acquisitions only
        '''''VI_FALSE (0) - Allow real-time and equivalent-time acquisitions
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureHorizontalTiming(ByVal Min_Sample_Rate As Double, ByVal Min_Num_Pts As Integer, ByVal Ref_Position As Double, ByVal Num_Records As Integer, ByVal Enforce_Realtime As Boolean) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureHorizontalTiming(Me._handle, Min_Sample_Rate, Min_Num_Pts, Ref_Position, Num_Records, System.Convert.ToUInt16(Enforce_Realtime))
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the attributes that control the electrical characteristics of the channel: the input impedance and the bandwidth.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''Name of the channel you want to configure.
        '''''
        '''''</param>
        '''''<param name="Input_Impedance">
        '''''The input impedance for the channel; NI-SCOPE sets NISCOPE_ATTR_INPUT_IMPEDANCE to this value. 
        '''''
        '''''</param>
        '''''<param name="Max_Input_Frequency">
        '''''The bandwidth for the channel; NI-SCOPE sets  NISCOPE_ATTR_MAX_INPUT_FREQUENCY to this value.
        '''''
        '''''Passing 0 for this value uses the default bandwidth of the hardware.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureChanCharacteristics(ByVal Channel_List As String, ByVal Input_Impedance As Double, ByVal Max_Input_Frequency As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureChanCharacteristics(Me._handle, Channel_List, Input_Impedance, Max_Input_Frequency)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the most commonly configured attributes of the digitizer vertical subsystem, such as the range, offset, coupling, probe attenuation, and the channel.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The name of the digitizer channel to configure.
        '''''
        '''''Valid Values: 
        '''''"0".."n-1",  n is the number of channels on the NI-SCOPE digitizer.
        '''''
        '''''</param>
        '''''<param name="Range">
        '''''Specifies the vertical range; NI-SCOPE uses this value to set NISCOPE_ATTR_VERTICAL_RANGE.
        '''''</param>
        '''''<param name="Offset">
        '''''Specifies the vertical offset; NI-SCOPE uses this value to set NISCOPE_ATTR_VERTICAL_OFFSET.
        '''''</param>
        '''''<param name="Coupling">
        '''''Specifies how to couple the input signal; NI-SCOPE uses this value to set NISCOPE_ATTR_VERTICAL_COUPLING.
        '''''</param>
        '''''<param name="Probe_Attenuation">
        '''''Specifies the probe attenuation; NI-SCOPE uses this value to set  NISCOPE_ATTR_PROBE_ATTENUATION.
        '''''</param>
        '''''<param name="Enabled">
        '''''Specifies whether the channel is enabled for acquisition; NI-SCOPE uses this value to set NISCOPE_ATTR_CHANNEL_ENABLED.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureVertical(ByVal Channel_List As String, ByVal Range As Double, ByVal Offset As Double, ByVal Coupling As Integer, ByVal Probe_Attenuation As Double, ByVal Enabled As Boolean) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureVertical(Me._handle, Channel_List, Range, Offset, Coupling, Probe_Attenuation, System.Convert.ToUInt16(Enabled))
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Returns the actual number of points the digitizer acquires for each channel. After configuring the digitizer for an acquisition, call this function to determine the size of the waveforms that the digitizer acquires. The value is equal to or greater than the minimum number of points specified in any of the Configure Horizontal functions.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Record_Length">
        '''''Returns the actual number of points the digitizer acquires for each channel; NI-SCOPE returns the value held in NISCOPE_ATTR_HORZ_RECORD_LENGTH.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ActualRecordLength(ByRef Record_Length As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ActualRecordLength(Me._handle, Record_Length)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Allows you to declare appropriately-sized waveforms. NI-SCOPE handles the channel list parsing for you. 
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel to acquire data from; it may be a single channel, such as "0" or "1",  or a list of channels, such as "0,1".
        '''''</param>
        '''''<param name="Num_Wfms">
        '''''Returns the number of records times the number of channels; if you are operating in DDC mode (NI 5620/5621 only), this value is  multiplied by two.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ActualNumWfms(ByVal Channel_List As String, ByRef Num_Wfms As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ActualNumWfms(Me._handle, Channel_List, Num_Wfms)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Returns the total available size of an array measurement acquisition. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Array_Meas_Function">
        '''''The measurement to be performed on the waveform. 
        '''''
        '''''Refer to the Array Measurements topic in the NI-SCOPE Function Reference Help for a list of defined values.
        '''''</param>
        '''''<param name="Meas_Waveform_Size">
        '''''Returns the size (in number of samples) of the resulting analysis waveform.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ActualMeasWfmSize(ByVal Array_Meas_Function As Integer, ByRef Meas_Waveform_Size As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ActualMeasWfmSize(Me._handle, Array_Meas_Function, Meas_Waveform_Size)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Returns the sample mode the digitizer is currently using. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Sample_Mode">
        '''''The sample mode the digitizer is currently using. NI-SCOPE returns the value in  NISCOPE_ATTR_SAMPLE_MODE.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function SampleMode(ByRef Sample_Mode As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.SampleMode(Me._handle, Sample_Mode)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Returns the effective sample rate of the acquired waveform using the current configuration in samples per second.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Sample_Rate">
        '''''Returns the effective sample rate of the acquired waveform the digitizer acquires for each channel; the driver returns the value held in NISCOPE_ATTR_HORZ_SAMPLE_RATE.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function SampleRate(ByRef Sample_Rate As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.SampleRate(Me._handle, Sample_Rate)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the common properties of a digital trigger. 
        '''''
        '''''When you initiate an acquisition, the digitizer waits for the start trigger, which is configured through the NISCOPE_ATTR_ACQ_ARM_SOURCE (Start Trigger Source) attribute. The default is immediate. Upon receiving the start trigger the digitizer begins sampling pretrigger points. After the digitizer finishes sampling pretrigger points, the digitizer waits for a reference (stop) trigger that you specify with a function such as this one. Upon receiving the reference trigger the digitizer finishes the acquisition after completing posttrigger sampling. With each Configure Trigger function, you specify configuration parameters such as the trigger source and the amount of trigger delay. 
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Trigger_Source">
        '''''Pass the source you want the digitizer to monitor for a trigger.  
        '''''
        '''''Valid Values: 
        '''''
        '''''NISCOPE_VAL_RTSI_0             - RTSI 0
        '''''NISCOPE_VAL_RTSI_1             - RTSI 1
        '''''NISCOPE_VAL_RTSI_2             - RTSI 2
        '''''NISCOPE_VAL_RTSI_3             - RTSI 3
        '''''NISCOPE_VAL_RTSI_4             - RTSI 4
        '''''NISCOPE_VAL_RTSI_5             - RTSI 5
        '''''NISCOPE_VAL_RTSI_6             - RTSI 6
        '''''NISCOPE_VAL_PFI_0              - PFI 0
        '''''NISCOPE_VAL_PFI_1              - PFI 1
        '''''NISCOPE_VAL_PFI_2              - PFI 2
        '''''NISCOPE_VAL_PXI_STAR           - PXI Star Trigger
        '''''</param>
        '''''<param name="Slope">
        '''''Specifies whether you want a rising edge or a falling edge to trigger the digitizer. Refer to NISCOPE_ATTR_TRIGGER_SLOPE for the defined values.
        '''''</param>
        '''''<param name="Holdoff">
        '''''The length of time the digitizer waits after detecting a trigger before enabling NI-SCOPE to detect another trigger; the units are seconds; NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_HOLDOFF.
        '''''</param>
        '''''<param name="Delay">
        '''''The length of time (in seconds) the digitizer waits after it receives the trigger to start acquiring data. NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_DELAY_TIME. 
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTriggerDigital(ByVal Trigger_Source As String, ByVal Slope As Integer, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerDigital(Me._handle, Trigger_Source, Slope, Holdoff, Delay)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures common properties for analog edge triggering. An edge trigger occurs when the trigger signal passes through the voltage threshold that you specify with the Trigger Level parameter and has the slope that you specify with the Trigger Slope parameter.  
        '''''
        '''''When you initiate an acquisition, the digitizer waits for the start trigger, which is configured through the NISCOPE_ATTR_ACQ_ARM_SOURCE (Start Trigger Source) attribute. The default is immediate. Upon receiving the start trigger the digitizer begins sampling pretrigger points. After the digitizer finishes sampling pretrigger points, the digitizer waits for a reference (stop) trigger that you specify with a function such as this one. Upon receiving the reference trigger the digitizer finishes the acquisition after completing posttrigger sampling. With each Configure Trigger function, you specify configuration parameters such as the trigger source and the amount of trigger delay. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Trigger_Source">
        '''''The trigger source; NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_SOURCE.
        '''''</param>
        '''''<param name="Level">
        '''''The voltage threshold for the trigger; NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_LEVEL.
        '''''</param>
        '''''<param name="Slope">
        '''''Specifies whether you want a rising edge or a falling edge to trigger the digitizer Refer to NISCOPE_ATTR_TRIGGER_SLOPE for the defined values.
        '''''</param>
        '''''<param name="Trigger_Coupling">
        '''''Applies coupling and filtering options to the trigger signal; NI-SCOPE uses this value to set  NISCOPE_ATTR_TRIGGER_COUPLING. 
        '''''</param>
        '''''<param name="Holdoff">
        '''''The length of time the digitizer waits after detecting a trigger before enabling NI-SCOPE to detect another trigger; the units are seconds; NI-SCOPE uses this value to set  NISCOPE_ATTR_TRIGGER_HOLDOFF.
        '''''</param>
        '''''<param name="Delay">
        '''''The length of time (in seconds) the digitizer waits after it receives the trigger to start acquiring data. NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_DELAY_TIME. 
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTriggerEdge(ByVal Trigger_Source As String, ByVal Level As Double, ByVal Slope As Integer, ByVal Trigger_Coupling As Integer, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerEdge(Me._handle, Trigger_Source, Level, Slope, Trigger_Coupling, Holdoff, Delay)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the common properties for video triggering, including the signal format, TV event, line number, polarity, and enable DC restore. A video trigger occurs when the digitizer finds a valid video signal sync. 
        '''''
        '''''When you initiate an acquisition, the digitizer waits for the start trigger, which is configured through the NISCOPE_ATTR_ACQ_ARM_SOURCE (Start Trigger Source) attribute. The default is immediate. Upon receiving the start trigger the digitizer begins sampling pretrigger points. After the digitizer finishes sampling pretrigger points, the digitizer waits for a reference (stop) trigger that you specify with a function such as this one. Upon receiving the reference trigger the digitizer finishes the acquisition after completing posttrigger sampling. With each Configure Trigger function, you specify configuration parameters such as the trigger source and the amount of trigger delay. 
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Trigger_Source">
        '''''The trigger source; valid trigger sources vary depending on your digitizer.
        '''''</param>
        '''''<param name="Enable_DC_Restore">
        '''''Offsets each video line so the clamping level (the portion of the video line between the end of the color burst and the beginning of the active image) is moved to zero volt.
        '''''</param>
        '''''<param name="Signal_Format">
        '''''Specifies the type of video signal sync the digitizer should look for.
        '''''</param>
        '''''<param name="Event">
        '''''Specifies the TV event you want to trigger on. You can trigger on a specific or on the next coming line or field of the signal.
        '''''</param>
        '''''<param name="Line_Number">
        '''''Selects the line number to trigger on. 
        '''''
        '''''Default Value: 1
        '''''</param>
        '''''<param name="Polarity">
        '''''Specifies the polarity of the video signal sync, either positive or negative.
        '''''</param>
        '''''<param name="Trigger_Coupling">
        '''''Specifies how you want the digitizer to couple the trigger signal; refer to NISCOPE_ATTR_TRIGGER_COUPLING for defined values.
        '''''  
        '''''
        '''''</param>
        '''''<param name="Holdoff">
        '''''Specifies the length of time the digitizer waits after detecting a trigger before enabling NI-SCOPE to detect another trigger; NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_HOLDOFF.Use the trigger holdoff to skip a specific number of frames between acquisitions. For example, to acquire a specific line number multiple times and repeat the same chroma phase, skip 1 frame in NTSC (35 ms &lt; holdoff &lt; 60 ms), 3 frames in PAL (121 ms &lt; holdoff &lt; 159 ms) and 5 frames in SECAM (201 ms &lt; holdoff &lt; 239 ms). 
        '''''
        '''''</param>
        '''''<param name="Delay">
        '''''The length of time (in seconds) the digitizer waits after it receives the trigger to start acquiring data. NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_DELAY_TIME. 
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTriggerVideo(ByVal Trigger_Source As String, ByVal Enable_DC_Restore As Boolean, ByVal Signal_Format As Integer, ByVal [Event] As Integer, ByVal Line_Number As Integer, ByVal Polarity As Integer, ByVal Trigger_Coupling As Integer, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerVideo(Me._handle, Trigger_Source, System.Convert.ToUInt16(Enable_DC_Restore), Signal_Format, [Event], Line_Number, Polarity, Trigger_Coupling, Holdoff, Delay)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures common properties for analog hysteresis triggering. This kind of trigger adds another value, specified in the hysteresis parameter, that a signal must pass through before a trigger can occur. This additional value acts as a kind of buffer zone that keeps noise from triggering an acquisition. 
        '''''
        '''''When you initiate an acquisition, the digitizer waits for the start trigger, which is configured through the NISCOPE_ATTR_ACQ_ARM_SOURCE (Start Trigger Source) attribute. The default is immediate. Upon receiving the start trigger the digitizer begins sampling pretrigger points. After the digitizer finishes sampling pretrigger points, the digitizer waits for a reference (stop) trigger that you specify with a function such as this one. Upon receiving the reference trigger the digitizer finishes the acquisition after completing posttrigger sampling. With each Configure Trigger function, you specify configuration parameters such as the trigger source and the amount of trigger delay. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Trigger_Source">
        '''''The source you want the digitizer to monitor for a trigger.  
        '''''
        '''''
        '''''</param>
        '''''<param name="Level">
        '''''The voltage threshold for the trigger; NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_LEVEL.
        '''''
        '''''</param>
        '''''<param name="Hysteresis">
        '''''The size of the hysteresis window on either side of the level in volts; the digitizer triggers when the trigger signal passes through the hysteresis value you specify with this parameter, has the slope you specify with slope, and passes through the level Refer to NISCOPE_ATTR_TRIGGER_HYSTERESIS for valid values.
        '''''</param>
        '''''<param name="Slope">
        '''''Specifies whether you want a rising edge or a falling edge to trigger the digitizer Refer to NISCOPE_ATTR_TRIGGER_SLOPE for the defined values.
        '''''</param>
        '''''<param name="Trigger_Coupling">
        '''''Applies coupling and filtering options to the trigger signal; NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_COUPLING.
        '''''
        '''''</param>
        '''''<param name="Holdoff">
        '''''The length of time the digitizer waits after detecting a trigger before enabling NI-SCOPE to detect another trigger; the units are in seconds; NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_HOLDOFF.
        '''''</param>
        '''''<param name="Delay">
        '''''The length of time (in seconds) the digitizer waits after it receives the trigger to start acquiring data. NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_DELAY_TIME. 
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTriggerHysteresis(ByVal Trigger_Source As String, ByVal Level As Double, ByVal Hysteresis As Double, ByVal Slope As Integer, ByVal Trigger_Coupling As Integer, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerHysteresis(Me._handle, Trigger_Source, Level, Hysteresis, Slope, Trigger_Coupling, Holdoff, Delay)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures common properties for immediate triggering. Immediate triggering means the digitizer triggers itself. 
        '''''
        '''''When you initiate an acquisition, the digitizer waits for a trigger. You specify the type of trigger that the digitizer waits for with a Configure Trigger function such as  this one. 
        '''''
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTriggerImmediate() As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerImmediate(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures common properties for software triggering. 
        '''''
        '''''When you initiate an acquisition, the digitizer waits for the start trigger, which is configured through the NISCOPE_ATTR_ACQ_ARM_SOURCE (Start Trigger Source) attribute. The default is immediate. Upon receiving the start trigger the digitizer begins sampling pretrigger points. After the digitizer finishes sampling pretrigger points, the digitizer waits for a reference (stop) trigger that you specify with a function such as this one. Upon receiving the reference trigger the digitizer finishes the acquisition after completing posttrigger sampling. With each Configure Trigger function, you specify configuration parameters such as the trigger source and the amount of trigger delay. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Holdoff">
        '''''The length of time the digitizer waits after detecting a trigger before enabling NI-SCOPE to detect another trigger; the units are seconds; NI-SCOPE uses this value to set  NISCOPE_ATTR_TRIGGER_HOLDOFF.
        '''''
        '''''
        '''''</param>
        '''''<param name="Delay">
        '''''The length of time (in seconds) the digitizer waits after it receives the trigger to start acquiring data. NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_DELAY_TIME. 
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTriggerSoftware(ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerSoftware(Me._handle, Holdoff, Delay)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures common properties for analog window triggering. A window trigger occurs when a signal enters or leaves a window you specify with the high level or low level parameters. 
        '''''
        '''''When you initiate an acquisition, the digitizer waits for the start trigger, which is configured through the NISCOPE_ATTR_ACQ_ARM_SOURCE (Start Trigger Source) attribute. The default is immediate. Upon receiving the start trigger the digitizer begins sampling pretrigger points. After the digitizer finishes sampling pretrigger points, the digitizer waits for a reference (stop) trigger that you specify with a function such as this one. Upon receiving the reference trigger the digitizer finishes the acquisition after completing posttrigger sampling. With each Configure Trigger function, you specify configuration parameters such as the trigger source and the amount of trigger delay. 
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Trigger_Source">
        '''''The source you want the digitizer to monitor for a trigger. Refer to NISCOPE_ATTR_TRIGGER_SOURCE for more information. 
        '''''
        '''''
        '''''</param>
        '''''<param name="Low_Level">
        '''''The voltage threshold you want the digitizer to use for low triggering. Refer to NISCOPE_ATTR_TRIGGER_WINDOW_LOW_LEVEL for more information.
        '''''</param>
        '''''<param name="High_Level">
        '''''the voltage threshold you want the digitizer to use for high triggering; refer to NISCOPE_ATTR_TRIGGER_WINDOW_HIGH_LEVEL for more information.
        '''''</param>
        '''''<param name="Window_Mode">
        '''''Specifies whether you want the trigger to occur when the signal enters or leaves a window. Refer to  NISCOPE_ATTR_TRIGGER_WINDOW_MODE for more information.
        '''''</param>
        '''''<param name="Trigger_Coupling">
        '''''Applies coupling and filtering options to the trigger signal; NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_COUPLING. 
        '''''
        '''''</param>
        '''''<param name="Holdoff">
        '''''The length of time (in seconds)  the digitizer waits after detecting a trigger before enabling NI-SCOPE to detect another trigger. NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_HOLDOFF.
        '''''</param>
        '''''<param name="Delay">
        '''''The length of time (in seconds) the digitizer waits after it receives the trigger to start acquiring data. NI-SCOPE uses this value to set NISCOPE_ATTR_TRIGGER_DELAY_TIME. 
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTriggerWindow(ByVal Trigger_Source As String, ByVal Low_Level As Double, ByVal High_Level As Double, ByVal Window_Mode As Integer, ByVal Trigger_Coupling As Integer, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerWindow(Me._handle, Trigger_Source, Low_Level, High_Level, Window_Mode, Trigger_Coupling, Holdoff, Delay)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Sends the selected trigger to the digitizer. Call this function if you called niScope_ConfigureTriggerSoftware when you want the Reference trigger to occur. You can also call this function to override a misused edge, digital, or hysteresis trigger. If you have configured NISCOPE_ATTR_ACQ_ARM_SOURCE,  NISCOPE_ATTR_ARM_REF_TRIG_SRC, or  NISCOPE_ATTR_ADV_TRIG_SRC, call this function when you want to send the corresponding trigger to the digitizer.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Which_Trigger">
        '''''The type of trigger to send to the digitizer.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function SendSoftwareTriggerEdge(ByVal Which_Trigger As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.SendSoftwareTriggerEdge(Me._handle, Which_Trigger)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the relative sample clock delay. Each time this function is called, the sample clock is delayed by the specified amount of time in seconds.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Delay">
        '''''The amount of time in seconds to delay the sample clock. Delay is a relative value, so repeated calls to this function  delays the sample clock by this amount every time.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function AdjustSampleClockRelativeDelay(ByVal Delay As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.AdjustSampleClockRelativeDelay(Me._handle, Delay)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the attributes for synchronizing the digitizer to a reference or sending the digitizer's reference clock output to be used as a synchronizing clock for other devices.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Input_Clock_Source">
        '''''Specifies the input source for the reference clock to which the 100 MHz sample clock is phase-locked. Refer to NISCOPE_ATTR_INPUT_CLOCK_SOURCE for more information. 
        '''''</param>
        '''''<param name="Output_Clock_Source">
        '''''Specifies the output source for the reference clock to which the sample clock of another digitizer can be phased-locked. Refer to NISCOPE_ATTR_OUTPUT_CLOCK_SOURCE for more information.
        '''''</param>
        '''''<param name="Clock_Sync_Pulse_Source">
        '''''For the NI 5102, specifies the line on which the sample clock is sent or received. For all other NI digitizers, specifies the line on which the one-time sync pulse is sent or received. This line should be the same for all devices to be synchronized. Refer to NISCOPE_ATTR_CLOCK_SYNC_PULSE_SOURCE for more information and for defined values.
        '''''</param>
        '''''<param name="Master_Enabled">
        '''''Specifies whether you want the device to be a master or a slave. The master device is typically the originator of the trigger signal and clock sync pulse. For a standalone device, set this attribute to VI_FALSE. 
        '''''
        '''''Refer to NISCOPE_ATTR_MASTER_ENABLE for more information.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureClock(ByVal Input_Clock_Source As String, ByVal Output_Clock_Source As String, ByVal Clock_Sync_Pulse_Source As String, ByVal Master_Enabled As Boolean) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureClock(Me._handle, Input_Clock_Source, Output_Clock_Source, Clock_Sync_Pulse_Source, System.Convert.ToUInt16(Master_Enabled))
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the digitizer to generate a signal pulse that other devices can detect when configured for digital triggering.  
        '''''
        '''''Note    For Traditional NI-DAQ devices, exported signals are still present in the route after the session is closed. You must clear the route before closing the session, or call niScope_reset. 
        '''''
        '''''To clear the route, call this function again and route NISCOPE_VAL_NONE to the line that you had exported. 
        '''''For example, if you originally called this function with the trigger event NISCOPE_VAL_STOP_TRIGGER_EVENT routed to the trigger output NISCOPE_VAL_RTSI_0, you would call this function again with NISCOPE_VAL_NONE routed to NISCOPE_VAL_RTSI_0 to clear the route.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Trigger_Event">
        '''''Specifies the condition in which this device will generate a digital pulse. .
        '''''
        '''''Valid Values
        '''''
        '''''NISCOPE_VAL_NO_EVENT
        '''''
        '''''NISCOPE_VAL_STOP_TRIGGER_EVENT 
        '''''
        '''''NISCOPE_VAL_START_TRIGGER_EVENT 
        '''''
        '''''NISCOPE_VAL_END_OF_ACQUISITION_EVENT 
        '''''
        '''''NISCOPE_VAL_END_OF_RECORD_EVENT 
        '''''
        '''''</param>
        '''''<param name="Trigger_Output">
        '''''Specifies the hardware signal line on which the digital pulse will be generated. Refer to NISCOPE_ATTR_TRIGGER_OUTPUT_SOURCE  for more information
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTriggerOutput(ByVal Trigger_Event As Integer, ByVal Trigger_Output As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerOutput(Me._handle, Trigger_Event, Trigger_Output)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the digitizer to generate a signal that other devices can detect when configured for digital triggering or sharing clocks. The signal parameter specifies what condition causes the digitizer to generate the signal. The outputTerminal parameter specifies where to send the signal on the hardware (such as a PFI connector or RTSI line). 
        '''''
        '''''In cases where multiple instances of a particular signal exist, use the signalIdentifier input to specify which instance to control. For normal signals, only one instance exists and you should leave this parameter set to the empty string. You can call this function multiple times and set each available line to a different signal.
        '''''
        '''''To unprogram a specific line on device, call this function with the signal you no longer want to export and set outputTerminal to None.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Signal">
        '''''Signal (clock, trigger, or event) to export. 
        '''''Defined Values
        '''''
        '''''Reference Trigger (1) Generate a pulse when detecting the Stop/Reference trigger.  
        '''''Start Trigger  (2) Generate a pulse when detecting a Start trigger. 
        '''''End of Acquisition Event  (3) Generate a pulse when the acquisition finishes. 
        '''''End of Record Event  (4) Generate a pulse at the end of the record. 
        '''''Advance Trigger  (5) Generate a pulse when detecting an Advance trigger. 
        '''''Ready for Advance Event  (6) Asserts when the digitizer is ready to advance to the next record. 
        '''''Ready for Start Event  (7) Asserts when the digitizer is initiated and ready to accept a Start trigger and begin sampling. 
        '''''Ready for Reference Event  (10) Asserts when the digitizer is ready to accept a Reference trigger. 
        '''''Reference Clock  (100) Export the Reference clock for the digitizer to the specified terminal. 
        '''''Sample Clock  (101) Export the Sample clock for the digitizer to the specified terminal. 
        '''''
        '''''</param>
        '''''<param name="Signal_Identifier">
        '''''Describes the signal being exported. 
        '''''</param>
        '''''<param name="Output_Terminal">
        '''''Identifies the hardware signal line on which the digital pulse is generated.
        ''''' 
        '''''Defined Values
        '''''
        '''''NISCOPE_VAL_RTSI_0  ("VAL_RTSI_0") 
        '''''NISCOPE_VAL_RTSI_1 ("VAL_RTSI_1") 
        '''''NISCOPE_VAL_RTSI_2 ("VAL_RTSI_2") 
        '''''NISCOPE_VAL_RTSI_3  ("VAL_RTSI_3") 
        '''''NISCOPE_VAL_RTSI_4 ("VAL_RTSI_4") 
        '''''NISCOPE_VAL_RTSI_5  ("VAL_RTSI_5") 
        '''''NISCOPE_VAL_RTSI_6 ("VAL_RTSI_6") 
        '''''NISCOPE_VAL_RTSI_7 ("VAL_RTSI_7") 
        '''''NISCOPE_VAL_PFI_0 ("VAL_PFI_0") 
        '''''NISCOPE_VAL_PFI_1 ("VAL_PFI_1") 
        '''''NISCOPE_VAL_PFI_2 ("VAL_PFI_2") 
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ExportSignal(ByVal Signal As Integer, ByVal Signal_Identifier As String, ByVal Output_Terminal As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ExportSignal(Me._handle, Signal, Signal_Identifier, Output_Terminal)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Configures the custom coefficients for the equalization FIR filter on the device. This filter is designed to compensate the input signal for artifacts introduced to the signal outside of the digitizer. Because this filter is a generic FIR filter, any coefficients are valid. Coefficient values should be between +1 and -1.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel on which to configure the filter. For more information, refer to Channel String Syntax in the NI-SCOPE Function Reference Help.
        '''''
        '''''</param>
        '''''<param name="Number_Of_Coefficients">
        '''''The number of coefficients being passed in the coefficients array. 
        '''''</param>
        '''''<param name="Coefficients">
        '''''The custom coefficients for the equalization FIR filter on the device. These coefficients should be between +1 and -1. 
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureEqualizationFilterCoefficients(ByVal Channel_List As String, ByVal Number_Of_Coefficients As Integer, ByVal Coefficients() As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureEqualizationFilterCoefficients(Me._handle, Channel_List, Number_Of_Coefficients, Coefficients)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Gets the frequency response of the data in the specified channel. 
        '''''
        '''''</summary>
        '''''<param name="channel">
        '''''channel specifies the channel from which to acquire data. 
        '''''</param>
        '''''<param name="bufferSize">
        '''''Specifies the length of the frequencies, amplitudes and phases arrays.
        '''''
        '''''</param>
        '''''<param name="frequencies">
        '''''The function fills the passed array with the frequencies that correspond with the amplitude and phase response of the device.
        '''''</param>
        '''''<param name="amplitudes">
        '''''The function fills the passed array with the magnitudes that correspond with the magnitude response of the device.
        '''''</param>
        '''''<param name="phases">
        '''''The function fills the passed array with the phases that correspond with the phase response of the device.
        '''''</param>
        '''''<param name="numberOfFrequencies">
        '''''numberOfFrequencies returns the number of frequencies in the returned spectrum.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function GetFrequencyResponse(ByVal channel As String, ByVal bufferSize As Integer, ByVal frequencies() As Double, ByVal amplitudes() As Double, ByVal phases() As Double, ByRef numberOfFrequencies As Integer)
            Dim pInvokeResult As Integer = PInvoke.GetFrequencyResponse(Me._handle, channel, bufferSize, frequencies, amplitudes, phases, numberOfFrequencies)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function


        '''''<summary>
        '''''Aborts an acquisition and returns the digitizer to the Idle state. This function is useful if the digitizer times out waiting for a trigger. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function Abort() As Integer
            Dim pInvokeResult As Integer = PInvoke.Abort(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Returns status information indicating whether an acquisition is in progress, complete, or unknown.  
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Acquisition_Status">
        '''''Returns the acquisition status of the digitizer.  Possible values that this parameter returns are:
        '''''
        '''''NISCOPE_VAL_ACQ_IN_PROGRESS (0) - The acquisition is in 
        '''''   progress
        '''''
        '''''NISCOPE_VAL_ACQ_COMPLETE (1) - The acquisition
        '''''   is complete.
        '''''
        '''''NISCOPE_VAL_ACQ_STATUS_UNKNOWN (-1) - The acquisition is in   
        '''''   an unknown state.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function AcquisitionStatus(ByRef Acquisition_Status As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.AcquisitionStatus(Me._handle, Acquisition_Status)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Commits to hardware all the parameter settings associated with the task. Use this function if you want a parameter change to be immediately reflected in the hardware. This function is only supported for the NI 5122/5124. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function Commit() As Integer
            Dim pInvokeResult As Integer = PInvoke.Commit(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Returns the waveform from a previously initiated acquisition that the digitizer acquires for the specified channel. This function returns scaled voltage waveforms.
        '''''
        '''''This function may return multiple waveforms depending on the number of channels, the acquisition type, and the number of records you specify. 
        '''''
        '''''Refer to &lt;a href="Using_Fetch_Functions.html"&gt;Using Fetch Functions&lt;/a&gt; for more information on using this function.
        '''''
        '''''Note You can use niScope_Read instead of this function. niScope_Read starts an acquisition on all enabled channels, waits for the acquisition to complete, and returns the waveform for the specified channel.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel name that you want to acquire data from, such as "0" or "1".
        '''''
        '''''This paramter may also be a list of channels, such as "0,1".  If a list is specified, the array of waveforms is ordered the same as the list.
        '''''
        '''''</param>
        '''''<param name="Timeout">
        '''''Time in seconds that you want to wait for the specified number of samples. A timeout of 0 means return whatever is available.
        '''''</param>
        '''''<param name="Num_Samples">
        '''''Number of samples to fetch for each record.
        '''''</param>
        '''''<param name="Wfm">
        '''''Returns an array whose length is the numSamples times number of waveforms; the number of waveforms can be determined by calling niScope_ActualNumWfms.
        '''''
        '''''NI-SCOPE returns this data sequentially, so all record 0 waveforms are first; for example, with a channel list of 0,1, you would have the following index values: 
        '''''
        '''''index 0 = record 0, channel 0 
        '''''
        '''''index x = record 0, channel 1 
        '''''
        '''''index 2x = record 1, channel 0 
        '''''
        '''''index 3x = record 1, channel 1 
        '''''
        '''''Where x = the record length
        '''''
        '''''</param>
        '''''<param name="Wfm_Info">
        '''''Returns an array of structures with the following timing and scaling information about each waveform: 
        '''''relativeInitialX-the time (in seconds) from the trigger to the first sample in the fetched waveform 
        '''''absoluteInitialX-timestamp (in seconds) of the first fetched sample that is comparable between records and acquisitions; your digitizer must support continuous acquisition 
        '''''xIncrement-the time between points in the acquired waveform in seconds 
        '''''actualSamples-the actual number of samples fetched and placed in the waveform array 
        '''''gain-the gain factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''offset-the offset factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''Call niScope_ActualNumWfms to find out the size of this array.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function Fetch(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, ByVal Wfm() As Double, ByVal Wfm_Info() As niScopeWfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.Fetch(Me._handle, Channel_List, Timeout, Num_Samples, Wfm, Wfm_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Retrieves data that the digitizer has acquired from a previously initiated acquisition and returns a one-dimensional array of complex, scaled waveforms.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel name that you want to acquire data from, such as "0" or "1".
        '''''
        '''''This paramter may also be a list of channels, such as "0,1".  If a list is specified, the array of waveforms is ordered the same as the list.
        '''''
        '''''</param>
        '''''<param name="Timeout">
        '''''The time to wait in seconds for data to be acquired; using 0 for this parameter tells NI-SCOPE to fetch whatever is currently available.
        '''''</param>
        '''''<param name="Num_Samples">
        '''''The maximum number of samples to fetch for each waveform. If the acquisition finishes with fewer points than requested, some devices return partial data if the acquisition finished, was aborted, or a timeout of 0 was used. Use -1 for this parameter if you want to fetch all available samples. The function reads the actual record length and attempts to acquire all available samples. If it fails to complete within the timeout period, the function returns an error.
        '''''</param>
        '''''<param name="Wfm">
        '''''Returns an array whose length is the numSamples times number of waveforms. Call niScope_ActualNumWfms to determine the number of waveforms. 
        '''''</param>
        '''''<param name="Wfm_Info">
        '''''Returns an array of structures with the following timing and scaling information about each waveform: 
        '''''relativeInitialX-the time (in seconds) from the trigger to the first sample in the fetched waveform 
        '''''absoluteInitialX-timestamp (in seconds) of the first fetched sample that is comparable between records and acquisitions; your digitizer must support continuous acquisition 
        '''''xIncrement-the time between points in the acquired waveform in seconds 
        '''''actualSamples-the actual number of samples fetched and placed in the waveform array 
        '''''gain-the gain factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''offset-the offset factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''Call niScope_ActualNumWfms to determine the size of this array.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function FetchComplex(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, ByVal Wfm() As niComplexNumber, ByVal Wfm_Info() As niScopeWfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchComplex(Me._handle, Channel_List, Timeout, Num_Samples, Wfm, Wfm_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Retrieves data that the digitizer has acquired from a previously initiated acquisition and returns binary 16-bit waveforms. 
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel name that you want to acquire data from, such as "0" or "1".
        '''''
        '''''This paramter may also be a list of channels, such as "0,1".  If a list is specified, the array of waveforms is ordered the same as the list.
        '''''
        '''''</param>
        '''''<param name="Timeout">
        '''''The time to wait in seconds for data to be acquired; using 0 for this parameter tells NI-SCOPE to fetch whatever is currently available.
        '''''</param>
        '''''<param name="Num_Samples">
        '''''The maximum number of samples to fetch for each waveform. If the acquisition finishes with fewer points than requested, some devices return partial data if the acquisition finished, was aborted, or a timeout of 0 was used. Use -1 for this parameter if you want to fetch all available samples. The function reads the actual record length and attempts to acquire all available samples. If it fails to complete within the timeout period, the function returns an error.
        '''''</param>
        '''''<param name="Wfm">
        '''''Returns an array whose length is the numSamples times number of waveforms. Call niScope_ActualNumWfms to determine the number of waveforms. 
        '''''</param>
        '''''<param name="Wfm_Info">
        '''''Returns an array of structures with the following timing and scaling information about each waveform: 
        '''''relativeInitialX-the time (in seconds) from the trigger to the first sample in the fetched waveform 
        '''''absoluteInitialX-timestamp (in seconds) of the first fetched sample that is comparable between records and acquisitions; your digitizer must support continuous acquisition 
        '''''xIncrement-the time between points in the acquired waveform in seconds 
        '''''actualSamples-the actual number of samples fetched and placed in the waveform array 
        '''''gain-the gain factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''offset-the offset factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''Call niScope_ActualNumWfms to determine the size of this array.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function FetchComplexBinary16(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, ByVal Wfm() As niComplexNumber16, ByVal Wfm_Info() As niScopeWfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchComplexBinary16(Me._handle, Channel_List, Timeout, Num_Samples, Wfm, Wfm_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Retrieves data from a previously initiated acquisition. It returns binary 8-bit waveforms. This function may return multiple waveforms depending on the number of channels, the acquisition type, and the number of records you specify. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel you will acquire data from; it may be a single channel, such as "0" or "1", or a list of channels such as "0,1"
        '''''</param>
        '''''<param name="Timeout">
        '''''Time in seconds that you want to wait for the specified number of samples. A timeout of 0 means return whatever is available.
        '''''</param>
        '''''<param name="Num_Samples">
        '''''The maximum number of samples to fetch for each waveform; if the acquisition finishes with fewer points than requested, partial data will be returned.
        '''''</param>
        '''''<param name="Wfm">
        '''''Returns an array whose length is the numSamples times number of waveforms; the number of waveforms can be determined by calling niScope_ActualNumWfms.
        '''''
        '''''NI-SCOPE returns this data sequentially, so all record 0 waveforms are first; for example, with a channel list of 0,1, you would have the following index values: 
        '''''
        '''''index 0 = record 0, channel 0 
        '''''
        '''''index x = record 0, channel 1 
        '''''
        '''''index 2x = record 1, channel 0 
        '''''
        '''''index 3x = record 1, channel 1 
        '''''
        '''''Where x = the record length
        '''''
        '''''</param>
        '''''<param name="Wfm_Info">
        '''''Returns an array of structures with the following timing and scaling information about each waveform: 
        '''''relativeInitialX-the time (in seconds) from the trigger to the first sample in the fetched waveform 
        '''''absoluteInitialX-timestamp (in seconds) of the first fetched sample that is comparable between records and acquisitions; your digitizer must support continuous acquisition 
        '''''xIncrement-the time between points in the acquired waveform in seconds 
        '''''actualSamples-the actual number of samples fetched and placed in the waveform array 
        '''''gain-the gain factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''offset-the offset factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''Call niScope_ActualNumWfms to find out the size of this array.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function FetchBinary8(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, ByVal Wfm() As SByte, ByVal Wfm_Info() As niScopeWfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchBinary8(Me._handle, Channel_List, Timeout, Num_Samples, Wfm, Wfm_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Retrieves data from a previously initiated acquisition. It returns binary 16-bit waveforms. This function may return multiple waveforms depending on the number of channels, the acquisition type, and the number of records you specify. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel you will acquire data from; it may be a single channel, such as "0" or "1", or a list of channels such as "0,1"
        '''''</param>
        '''''<param name="Timeout">
        '''''Time in seconds that you want to wait for the specified number of samples. A timeout of 0 means return whatever is available.
        '''''</param>
        '''''<param name="Num_Samples">
        '''''The maximum number of samples to fetch for each waveform; if the acquisition finishes with fewer points than requested, partial data will be returned.
        '''''</param>
        '''''<param name="Wfm">
        '''''Returns an array whose length is the numSamples times number of waveforms; the number of waveforms can be determined by calling niScope_ActualNumWfms 
        '''''
        '''''NI-SCOPE returns this data sequentially, so all record 0 waveforms are first; for example, with a channel list of 0,1, you would have the following index values: 
        '''''
        '''''index 0 = record 0, channel 0 
        '''''
        '''''index x = record 0, channel 1 
        '''''
        '''''index 2x = record 1, channel 0 
        '''''
        '''''index 3x = record 1, channel 1 
        '''''
        '''''Where x = the record length
        '''''
        '''''</param>
        '''''<param name="Wfm_Info">
        '''''Returns an array of structures with the following timing and scaling information about each waveform: 
        '''''relativeInitialX-the time (in seconds) from the trigger to the first sample in the fetched waveform 
        '''''absoluteInitialX-timestamp (in seconds) of the first fetched sample that is comparable between records and acquisitions; your digitizer must support continuous acquisition 
        '''''xIncrement-the time between points in the acquired waveform in seconds 
        '''''actualSamples-the actual number of samples fetched and placed in the waveform array 
        '''''gain-the gain factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''offset-the offset factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''Call niScope_ActualNumWfms to find out the size of this array.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function FetchBinary16(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, ByVal Wfm() As Short, ByVal Wfm_Info() As niScopeWfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchBinary16(Me._handle, Channel_List, Timeout, Num_Samples, Wfm, Wfm_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Retrieves data from a previously initiated acquisition. It returns binary 32-bit waveforms. This function may return multiple waveforms depending on the number of channels, the acquisition type, and the number of records you specify. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel you will acquire data from; it may be a single channel, such as "0" or "1", or a list of channels such as "0,1"
        '''''
        '''''</param>
        '''''<param name="Timeout">
        '''''Time in seconds that you want to wait for the specified number of samples. A timeout of 0 means return whatever is available.
        '''''</param>
        '''''<param name="Num_Samples">
        '''''The maximum number of samples to fetch for each waveform; if the acquisition finishes with fewer points than requested, partial data will be returned.
        '''''</param>
        '''''<param name="Wfm">
        '''''Returns an array whose length is the numSamples times number of waveforms; the number of waveforms can be determined by calling niScope_ActualNumWfms 
        '''''NI-SCOPE returns this data sequentially, so all record 0 waveforms are first; for example, with a channel list of 0,1, you would have the following index values: 
        '''''
        '''''index 0 = record 0, channel 0 
        '''''
        '''''index x = record 0, channel 1 
        '''''
        '''''index 2x = record 1, channel 0 
        '''''
        '''''index 3x = record 1, channel 1 
        '''''
        '''''Where x = the record length
        '''''
        '''''</param>
        '''''<param name="Wfm_Info">
        '''''Returns an array of structures with the following timing and scaling information about each waveform: 
        '''''relativeInitialX-the time (in seconds) from the trigger to the first sample in the fetched waveform 
        '''''absoluteInitialX-timestamp (in seconds) of the first fetched sample that is comparable between records and acquisitions; your digitizer must support continuous acquisition 
        '''''xIncrement-the time between points in the acquired waveform in seconds 
        '''''actualSamples-the actual number of samples fetched and placed in the waveform array 
        '''''gain-the gain factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''offset-the offset factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''Call niScope_ActualNumWfms to find out the size of this array.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function FetchBinary32(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, ByVal Wfm() As Integer, ByVal Wfm_Info() As niScopeWfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchBinary32(Me._handle, Channel_List, Timeout, Num_Samples, Wfm, Wfm_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Initiates a waveform acquisition. After you call this function, the digitizer leaves the Idle state and waits for a trigger. The digitizer acquires a waveform for each channel you enable with niScope_ConfigureVertical. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function InitiateAcquisition() As Integer
            Dim pInvokeResult As Integer = PInvoke.InitiateAcquisition(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Initiates an acquisition, waits for it to complete, and retrieves the data. The process is similar to calling niScope_InitiateAcquisition, niScope_AcquisitionStatus, and niScope_Fetch. The only difference is that by using niScope_Read, you enable all channels specified with channelList before the acquisition; in the other method, you enable the channels with niScope_ConfigureVertical. 
        '''''
        '''''This function may return multiple waveforms depending on the number of channels, the acquisition type, and the number of records you specify.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel that you will acquire data from; it may be a single channel, such as "0" or "1", or a list of channels such as "0,1"
        '''''</param>
        '''''<param name="Timeout">
        '''''Time in seconds that you want to wait for the specified number of samples. A timeout of 0 means return whatever is available.
        '''''</param>
        '''''<param name="Num_Samples">
        '''''The maximum number of samples to fetch for each waveform; if the acquisition finishes with fewer points than requested, partial data will be returned.
        '''''</param>
        '''''<param name="Wfm">
        '''''Returns an array whose length is the numSamples times number of waveforms; the number of waveforms can be determined by calling niScope_ActualNumWfms. 
        '''''
        '''''NI-SCOPE returns this data sequentially, so all record 0 waveforms are first; for example, with a channel list of 0,1, you would have the following index values: 
        '''''
        '''''index 0 = record 0, channel 0 
        '''''
        '''''index x = record 0, channel 1 
        '''''
        '''''index 2x = record 1, channel 0 
        '''''
        '''''index 3x = record 1, channel 1 
        '''''
        '''''Where x = the record length
        '''''</param>
        '''''<param name="Wfm_Info">
        '''''Returns an array of structures with the following timing and scaling information about each waveform: 
        '''''relativeInitialX-the time from the trigger to the first sample in the fetched waveform 
        '''''absoluteInitialX-timestamp of the first fetched sample that is comparable between records and acquisitions; your digitizer must support continuous acquisition 
        '''''xIncrement-the time between points in the acquired waveform in seconds 
        '''''actualSamples-the actual number of samples fetched and placed in the waveform array 
        '''''gain-the gain factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = (binary data * gain factor) + offset 
        '''''
        '''''offset-the offset factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = (binary data * gain factor) + offset 
        '''''
        '''''Call niScope_ActualNumWfms to find out the size of this array.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function Read(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, ByVal Wfm() As Double, ByVal Wfm_Info() As niScopeWfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.Read(Me._handle, Channel_List, Timeout, Num_Samples, Wfm, Wfm_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Adds one measurement to the list of processing steps that are completed before the measurement. The processing is added on a per channel basis, and the processing measurements are completed in the same order they are registered. All measurement library parameters--the attributes starting with NISCOPE_ATTR_MEAS--are cached at the time of registering the processing, and this set of parameters is used during the processing step. The processing measurements are streamed, so the result of the first processing step is used as the input for the next step. The processing is done before any other measurements. 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel to which the processing step is added, such as "0" or "1".
        '''''
        '''''</param>
        '''''<param name="Meas_Function">
        '''''The measurement to be added as a processing step.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function AddWaveformProcessing(ByVal Channel_List As String, ByVal Meas_Function As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.AddWaveformProcessing(Me._handle, Channel_List, Meas_Function)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Clears the waveform stats on the channel and measurement you specify. To clear all of the measurements, use NISCOPE_VAL_ALL_MEASUREMENTS in the clearableMeasurementFunction parameter. 
        '''''
        '''''Every time a measurement is called, the statistics information is updated, including the min, max, mean, standard deviation, and number of updates. This information is fetched with niScope_FetchWaveformMeasurementStats. The multi-acquisition array measurements are also cleared with this function. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel for the measurements you wish to clear, such as "0" or "1".
        '''''
        '''''</param>
        '''''<param name="Clearable_Measurement_Function">
        '''''The measurement to clear the stats for.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ClearWaveformMeasurementStats(ByVal Channel_List As String, ByVal Clearable_Measurement_Function As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ClearWaveformMeasurementStats(Me._handle, Channel_List, Clearable_Measurement_Function)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Clears the list of processing steps assigned to the given channel. The processing is added with the niScope_AddWaveformProcessing function, where the processing steps are completed in the same order in which they are registered. The processing measurements are streamed, so the result of the first processing step is used as the input for the next step. The processing is also done before any other measurements
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel for the processing you wish to clear, such as "0" or "1".
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ClearWaveformProcessing(ByVal Channel_List As String) As Integer
            Dim pInvokeResult As Integer = PInvoke.ClearWaveformProcessing(Me._handle, Channel_List)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Obtains a waveform from the digitizer and returns the specified measurement array. This function may return multiple waveforms depending on the number of channels, the acquisition type, and the number of records you specify.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel that you will acquire data from; it may be a single channel, such as "0" or "1", or a list of channels such as "0,1"
        '''''</param>
        '''''<param name="Timeout">
        '''''Time in seconds that you want to wait for the specified number of samples. A timeout of 0 means return whatever is available.
        '''''</param>
        '''''<param name="Array_Meas_Function">
        '''''The measurement to be performed on the waveform.
        '''''</param>
        '''''<param name="Meas_Wfm_Size">
        '''''The size of each waveform to fetch. Call niScope_ActualMeasWfmSize to find the resulting size of the  array measurement.
        '''''
        '''''
        '''''</param>
        '''''<param name="Meas_Wfm">
        '''''Returns an array whose length is the number of waveforms times measWfmSize; the number of waveforms is determined by calling niScope_ActualNumWfms; the size of each waveform can be determined by calling niScope_ActualMeasWfmSize 
        '''''
        '''''NI-SCOPE returns this data sequentially, so all record 0 waveforms are first. For example, with channel list of 0, 1, you would have the following index values: 
        '''''
        '''''index 0 = record 0, channel 0 
        '''''
        '''''index x = record 0, channel 1 
        '''''
        '''''index 2x = record 1, channel 0 
        '''''
        '''''index 3x = record 1, channel 1 
        '''''
        '''''Where x = the record length
        '''''
        '''''</param>
        '''''<param name="Wfm_Info">
        '''''Returns an array of structures with the following timing and scaling information about each waveform: 
        '''''
        '''''relativeInitialX--the time (in seconds) from the trigger to the first sample in the fetched waveform 
        '''''absoluteInitialX--timestamp (in seconds) of the first fetched sample that is comparable between records and acquisitions; your digitizer must support continuous acquisition 
        '''''xIncrement--the time between points in the acquired waveform in seconds 
        '''''actualSamples--the actual number of samples fetched and placed in the waveform array 
        '''''gain--the gain factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''offset--the offset factor of the given channel; useful for scaling binary data with this formula 
        '''''voltage = binary data * gain factor + offset 
        '''''
        '''''Call niScope_ActualNumWfms to find out the size of this array.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function FetchArrayMeasurement(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Array_Meas_Function As Integer, ByVal Meas_Wfm_Size As Integer, ByVal Meas_Wfm() As Double, ByVal Wfm_Info() As niScopeWfmInfo) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchArrayMeasurement(Me._handle, Channel_List, Timeout, Array_Meas_Function, Meas_Wfm_Size, Meas_Wfm, Wfm_Info)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Fetches a waveform from the digitizer and performs the specified waveform measurement.
        '''''
        '''''Many of the measurements use the low, mid, and high reference levels, which ou configure by using the attributes NISCOPE_ATTR_MEAS_CHAN_LOW_REF_LEVEL, NISCOPE_ATTR_MEAS_CHAN_MID_REF_LEVEL, and NISCOPE_ATTR_MEAS_CHAN_HIGH_REF_LEVEL to set each channel differently. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel name that you want to acquire data from, such as "0" or "1".
        '''''
        '''''This may also be a list of channels, such as "0,1".  If a list is specified, the array of waveforms is ordered the same as the list.
        '''''
        '''''</param>
        '''''<param name="Timeout">
        '''''Time in seconds that you want to wait for the specified number of samples. A timeout of 0 means return whatever is available.
        '''''</param>
        '''''<param name="Scalar_Meas_Function">
        '''''The scalar measurement to be performed.
        '''''</param>
        '''''<param name="Result">
        '''''An array of results of the specified scalar measurement that includes waveforms from multiple channels, records, and acquisition types.  For example, if the acquisition type is normal there is one waveform per channel per record.  If you call  the fetch measurement function during a normal acquisition  and the channel string is  "0,1",  the order of the output is:
        '''''
        '''''-Index 0: measurement result for record 0,  channel 0,
        '''''-Index 1: measurement result for record 0,  channel 1,
        '''''-Index 2: measurement result for record 1,  channel 0,
        '''''-Index 3: measurement result for record 1,  channel 1,
        '''''
        '''''The order of the channels is the order specified by the channel list parameter.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function FetchMeasurement(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Scalar_Meas_Function As Integer, ByVal Result() As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchMeasurement(Me._handle, Channel_List, Timeout, Scalar_Meas_Function, Result)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Obtains a waveform measurement and returns the measurement value. This function may return multiple statistical results depending on the number of channels, the acquisition type, and the number of records you specify. 
        '''''
        '''''You specify a particular measurement type, such as rise time, frequency, or voltage peak-to-peak. The waveform on which the digitizer calculates the waveform measurement is from an acquisition that you previously initiated. The statistics for the specified measurement function are returned, where the statistics are updated once every acquisition when the specified measurement is fetched by any of the Fetch Measurement functions. If a Fetch Measurement function has not been called, this function fetches the data on which to perform the measurement. The statistics are cleared by calling niScope_ClearWaveformMeasurementStats. 
        '''''
        '''''Many of the measurements use the low, mid, and high reference levels, which you configure with the attributes NISCOPE_ATTR_MEAS_CHAN_LOW_REF_LEVEL, NISCOPE_ATTR_MEAS_CHAN_MID_REF_LEVEL, and NISCOPE_ATTR_MEAS_CHAN_HIGH_REF_LEVEL to set each channel differently. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel that you will acquire data from; it may be a single channel, such as "0" or "1", or a list of channels such as "0,1"
        '''''</param>
        '''''<param name="Timeout">
        '''''Time in seconds that you want to wait for the specified number of samples. A timeout of 0 means return whatever is available.
        '''''</param>
        '''''<param name="Scalar_Meas_Function">
        '''''The scalar measurement to be performed on each fetched waveform.
        '''''</param>
        '''''<param name="Result">
        '''''Returns the resulting measurement.
        '''''</param>
        '''''<param name="Mean">
        '''''Returns the mean scalar value, which is obtained by averaging each niScope_FetchMeasurementStats call.
        '''''</param>
        '''''<param name="Stdev">
        '''''Returns the standard deviation of the most recent numInStats measurements.
        '''''</param>
        '''''<param name="Min">
        '''''Returns the smallest scalar value acquired (the minimum of the numInStats measurements)
        '''''</param>
        '''''<param name="Max">
        '''''Returns the largest scalar value acquired (the maximum of the numInStats measurements).
        '''''</param>
        '''''<param name="Num_In_Stats">
        '''''Returns the number of times niScope_FetchMeasurementStats has been called.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function FetchMeasurementStats(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Scalar_Meas_Function As Integer, ByVal Result() As Double, ByVal Mean() As Double, ByVal Stdev() As Double, ByVal Min() As Double, ByVal Max() As Double, ByVal Num_In_Stats() As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchMeasurementStats(Me._handle, Channel_List, Timeout, Scalar_Meas_Function, Result, Mean, Stdev, Min, Max, Num_In_Stats)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Initiates an acquisition, waits for it to complete, and performs the specified waveform measurement for a single channel and record or for multiple channels and records.
        '''''
        '''''Many of the measurements use the low, mid, and high reference levels, which you configure by using the attributes NISCOPE_ATTR_MEAS_CHAN_LOW_REF_LEVEL, NISCOPE_ATTR_MEAS_CHAN_MID_REF_LEVEL, and NISCOPE_ATTR_MEAS_CHAN_HIGH_REF_LEVEL to set each channel differently.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''The channel that you will acquire data from; it may be a single channel, such as "0" or "1", or a list of channels such as "0,1"
        '''''</param>
        '''''<param name="Timeout">
        '''''Time in seconds that you want to wait for the specified number of samples. A timeout of 0 means return whatever is available.
        '''''</param>
        '''''<param name="Scalar_Meas_Function">
        '''''The scalar measurement to be performed.
        '''''</param>
        '''''<param name="Result">
        '''''Contains an array of all measurements acquired; the array length can be determined by calling niScope_ActualNumWfms.
        '''''
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ReadMeasurement(ByVal Channel_List As String, ByVal Timeout As Double, ByVal Scalar_Meas_Function As Integer, ByVal Result() As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadMeasurement(Me._handle, Channel_List, Timeout, Scalar_Meas_Function, Result)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Self-calibrates the digitizer. Refer to Features Supported by Device to find out if your digitizer supports self-calibration.
        '''''
        '''''For the NI 5122/5124, if the self-calibration is performed successfully in a regular session, the calibration constants are immediately stored in the self-calibration area of the EEPROM. If the self-calibration is performed in an external calibration session, the calibration constants take effect immediately for the duration of the session. However, they are not stored in the EEPROM until you call niScope_CalEnd with action set to NISCOPE_VAL_ACTION_STORE, and no errors occur.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel_List">
        '''''Pass the channel the reference voltage is connected to.
        '''''
        '''''Valid Values: 
        '''''0..n-1,  n is the number of channels on the NI SCOPE device
        '''''
        '''''</param>
        '''''<param name="Option">
        '''''Only NISCOPE_VAL_CAL_RESTORE_EXTERNAL_CALIBRATION is supported; use VI_NULL for a normal self-calibration operation.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function CalSelfCalibrate(ByVal Channel_List As String, ByVal [Option] As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.CalSelfCalibrate(Me._handle, Channel_List, [Option])
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Performs a hard reset of the device. Acquisition stops, all routes are released, RTSI and PFI lines are tri-stated, hardware is configured to its default state, and all session attributes are reset to their default state. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ResetDevice() As Integer
            Dim pInvokeResult As Integer = PInvoke.ResetDevice(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Aborts any current operation, opens data channel relays, and releases RTSI and PFI lines. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function Disable() As Integer
            Dim pInvokeResult As Integer = PInvoke.Disable(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Starts the 1 kHz square wave output on PFI 1 for probe compensation. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ProbeCompensationSignalStart() As Integer
            Dim pInvokeResult As Integer = PInvoke.ProbeCompensationSignalStart(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Stops the 1 kHz square wave output on PFI 1 for probe compensation.
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ProbeCompensationSignalStop() As Integer
            Dim pInvokeResult As Integer = PInvoke.ProbeCompensationSignalStop(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Resets the instrument to the default state.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function reset() As Integer
            Dim pInvokeResult As Integer = PInvoke.reset(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Performs a software reset of the device, returning it to the default state and applying any initial default settings from the IVI Configuration Store. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ResetWithDefaults() As Integer
            Dim pInvokeResult As Integer = PInvoke.ResetWithDefaults(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Returns the revision numbers of the instrument driver and instrument firmware.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Driver_Revision">
        '''''Returns the instrument driver software revision numbers in the form of a string.
        '''''
        '''''You must pass a ViChar array at least 256 bytes in length.
        '''''</param>
        '''''<param name="Firmware_Revision">
        '''''Returns the instrument firmware revision numbers in the form of a string.
        '''''
        '''''You must pass a ViChar array at least 256 bytes in length.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function revision_query(ByVal Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.revision_query(Me._handle, Driver_Revision, Firmware_Revision)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Runs the instrument's self-test routine and returns the test result(s). 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Self_Test_Result">
        '''''Contains the value returned from the instrument self-test.  
        '''''
        '''''Self-Test Code    Description
        '''''---------------------------------------
        '''''   0              Self-test passed
        '''''   1              Self-test failed
        '''''
        '''''</param>
        '''''<param name="Self_Test_Message">
        '''''Returns the self-test response string from the instrument. 
        '''''
        '''''You must pass a ViChar array at least 256 bytes in length.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function self_test(ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.self_test(Me._handle, Self_Test_Result, Self_Test_Message)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Takes the error code returned by NI-SCOPE functions and returns the interpretation as a user-readable string. 
        '''''
        '''''Note  You can pass VI_NULL as the instrument handle, which is useful to interpret errors after niScope_init has failed.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Error_Code">
        '''''Pass the Error Code that is returned from any of the instrument driver functions.
        '''''</param>
        '''''<param name="Error_Source">
        '''''Returns the name of the function where the error was generated.
        '''''
        '''''You must pass a ViChar array at least MAX_FUNCTION_NAME_SIZE bytes in length.
        '''''
        '''''</param>
        '''''<param name="Error_Description">
        '''''Returns the interpreted Error Code as a user readable message string.
        '''''
        '''''You must pass a ViChar array at least MAX_ERROR_DESCRIPTION bytes in length.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function errorHandler(ByVal Error_Code As Integer, ByVal Error_Source As System.Text.StringBuilder, ByVal Error_Description As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.errorHandler(Me._handle, Error_Code, Error_Source, Error_Description)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''Returns the error code from an NI-SCOPE function  as a user-readable string. Use VI_NULL as the default instrument handle. 
        '''''</summary>        
        '''''<param name="Error_Code">
        '''''The error code that is returned from any of the instrument driver functions.
        '''''</param>
        '''''<param name="Buffer_Size">
        '''''The number of bytes you specify for the errorMessage parameter.  
        '''''</param>
        '''''<param name="Error_Message">
        '''''Returns a buffer that will be populated with the error message.  It should be at least as large as the  buffer size.        
        '''''</param>
        '''''<returns>
        '''''Reports the status of this operation.
        '''''To obtain a text description of the status code, call niScope_GetErrorMessage. 
        '''''To obtain additional information concerning the error condition, use niScope_GetError 
        '''''and niScope_ClearError.   
        '''''</returns>
        '''''<remarks>
        '''''You must call this function twice.  For the first call,  set bufferSize to 0 to prevent the function from populating the error message. Instead, the function returns the size of the error string.  Use the returned size to create a buffer, then call the function again,  passing in the new buffer and setting  bufferSize equal to the size that was returned in the first function call.        
        '''''</remarks>
        Public Function GetErrorMessage(ByVal Error_Code As Integer, ByVal Buffer_Size As Integer, ByVal Error_Message As System.Text.StringBuilder)
            Dim pInvokeResult As Integer = PInvoke.GetErrorMessage(Me._handle, Error_Code, Buffer_Size, Error_Message)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Configures the most commonly configured attributes of the instrument acquisition subsystem.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Time_per_Record">
        '''''Specifies the time per record.
        '''''
        '''''Units: Seconds.
        '''''</param>
        '''''<param name="Min_Num_Points">
        '''''Pass the minimum number of points you require in the record for each channel.  Call niScope_ActualRecordLength to obtain the actual record length used.
        '''''
        '''''Valid Values:  1 - available onboard memory
        '''''
        '''''</param>
        '''''<param name="Acquisition_Start_Time">
        '''''Specifies the position of the first point in the waveform record relative to the trigger event.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureAcquisitionRecord(ByVal Time_per_Record As Double, ByVal Min_Num_Points As Integer, ByVal Acquisition_Start_Time As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureAcquisitionRecord(Me._handle, Time_per_Record, Min_Num_Points, Acquisition_Start_Time)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Configures the most commonly configured attributes of the istrument's channel subsystem.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel">
        '''''Specifies the channel(s) to be configured.
        '''''
        '''''Default Value: "0"
        '''''
        '''''Valid Range:   "0"
        '''''               "1"
        '''''               "0,1"
        '''''               "1,0"
        '''''               ""
        '''''</param>
        '''''<param name="Range">
        '''''Specifies the voltage range for the specified channel(s).
        '''''</param>
        '''''<param name="Offset">
        '''''Selects the DC offset added to the specified channel(s).
        '''''
        '''''Default Value: 0
        '''''</param>
        '''''<param name="Coupling">
        '''''Specify how you want the digitizer to couple the input signal for the channel.  
        '''''
        '''''Valid Values:
        '''''  NISCOPE_VAL_AC  - AC Coupling
        '''''  NISCOPE_VAL_DC  - DC Coupling
        '''''  NISCOPE_VAL_GND - GND Coupling
        '''''
        '''''NOTE: A certain amount of delay is required for the coupling capacitor to charge after changing vertical coupling from DC to AC.  This delay is typically:
        '''''   Low Impedance Source - 150 ms
        '''''   10X Probe            - 1.5 s
        '''''   100X Probe           - 15 s
        '''''</param>
        '''''<param name="Probe_Attenuation">
        '''''Specifies the probe attenuation for the specified channel(s).
        '''''
        '''''Default Value: 1.00
        '''''
        '''''Valid Range:   1.00 - 100
        '''''
        '''''Notes:
        '''''(1) If you have a probe with yX attenuation, set this parameter to y. For example, a value of 10 would be entered for a 10X probe.
        '''''</param>
        '''''<param name="Enabled">
        '''''Specify whether to enable the digitizer to acquire data for the channel when you call niScope_InitiateAcquisition.
        '''''
        '''''Valid Values:
        '''''NISCOPE_VI_TRUE  (1) - Acquire data on this channel
        '''''NISCOPE_VI_FALSE (0) - Don't acquire data on this channel
        '''''
        '''''Default Value:
        '''''NISCOPE_VI_TRUE (1)
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureChannel(ByVal Channel As String, ByVal Range As Double, ByVal Offset As Double, ByVal Coupling As Integer, ByVal Probe_Attenuation As Double, ByVal Enabled As Boolean) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureChannel(Me._handle, Channel, Range, Offset, Coupling, Probe_Attenuation, System.Convert.ToUInt16(Enabled))
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Sets the edge triggering attributes. An edge trigger occurs when the trigger signal specified with the source parameter passes through the voltage threshold specified with the level parameter and has the slope specified with the slope parameter.
        '''''
        '''''This function affects instrument behavior only if the triggerType is NISCOPE_VAL_EDGE.  Set the trigger type and trigger coupling before calling this function.
        '''''
        '''''If the trigger source is one of the analog input channels, you must configure the vertical range, vertical offset, vertical coupling, probe attenuation, and the maximum input frequency before calling this function.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Source">
        '''''Pass the source you want the instrument to monitor for a trigger.  
        '''''
        '''''Valid Values: 
        '''''
        '''''"0",                     - Channel 0
        '''''"1",                     - Channel 1
        '''''NISCOPE_VAL_EXTERNAL     - Analog External Trigger Input
        '''''
        '''''</param>
        '''''<param name="Level">
        '''''Pass the voltage threshold you want the instrument to use for edge triggering.  
        '''''
        '''''The digitizer triggers when the trigger signal passes through the threshold you specify with this parameter and has the slope you specify with the Slope parameter.
        '''''
        '''''Units:  volts
        '''''</param>
        '''''<param name="Slope">
        '''''Specify whether you want a rising edge or a falling edge passing through the Trigger Level to trigger the instrument.  
        '''''
        '''''Defined Values:
        '''''  NISCOPE_VAL_POSITIVE - Rising edge
        '''''  NISCOPE_VAL_NEGATIVE - Falling edge
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureEdgeTriggerSource(ByVal Source As String, ByVal Level As Double, ByVal Slope As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureEdgeTriggerSource(Me._handle, Source, Level, Slope)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Configures the common attributes of the trigger subsystem.
        '''''
        '''''When you use niScope_ReadWaveform, the instrument waits for a trigger. You specify the type of trigger for which the instrument waits with the Trigger Type parameter.
        '''''
        '''''If the instrument reauires multiple waveform acquisitions to build a complete waveform, it waits for the length of time you specify with the Holdoff parameter to elapse since the previous trigger. The instrument then waits for the next trigger.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Trigger_Type">
        '''''Specifies the type of trigger for which the instrument will wait.
        '''''</param>
        '''''<param name="Holdoff">
        '''''Specifies the trigger holdoff, which is the length of time that will elapse before the instrument waits for the next trigger.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTrigger(ByVal Trigger_Type As Integer, ByVal Holdoff As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTrigger(Me._handle, Trigger_Type, Holdoff)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Sets the trigger coupling attribute.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Coupling">
        '''''Specify how you want the instrument to couple the trigger signal.  
        '''''
        '''''Defined Values:
        '''''  NISCOPE_VAL_AC - AC coupling
        '''''  NISCOPE_VAL_DC - DC coupling
        '''''  NISCOPE_VAL_HF_REJECT - High Frequency Reject
        '''''  NISCOPE_VAL_LF_REJECT - Low Frequency Reject
        '''''  NISCOPE_VAL_AC_PLUS_HF_REJECT - AC coupling and High Frequency  Reject
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTriggerCoupling(ByVal Coupling As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerCoupling(Me._handle, Coupling)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Configures the TV line upon which the instrument triggers. The line number is absolute and not relative to the field of the TV signal.
        '''''
        '''''This function affects instrument behavior only if the trigger type is set to NISCOPE_VAL_TV_TRIGGER  and the TV trigger event is set to  NISCOPE_VAL_TV_EVENT_LINE_NUMBER. Call  niScope_ConfigureTVTriggerSource  to set the TV trigger event before calling this function.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Line_Number">
        '''''Specify the line number of the signal you want to trigger off of. The valid ranges of the attribute depend on the signal format configured. NTSC has valid ranges of 1 to 525.  PAL and SECAM have valid ranges from 1 to 625.
        '''''
        '''''Default Value: 1
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTVTriggerLineNumber(ByVal Line_Number As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTVTriggerLineNumber(Me._handle, Line_Number)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Configures the instrument for TV triggering. It configures the TV signal format, the event,  and the signal polarity.
        '''''
        '''''This function affects instrument behavior only if the trigger type is NISCOPE_VAL_TV_TRIGGER. Set the trigger type and trigger coupling before calling this function.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Source">
        '''''Pass the source you want the digitizer to monitor for a trigger.  
        '''''
        '''''Valid Values: 
        '''''
        '''''"0",                     - Channel 0
        '''''"1",                     - Channel 1
        '''''NISCOPE_VAL_EXTERNAL     - Analog External Trigger Input
        '''''
        '''''</param>
        '''''<param name="Signal_Format">
        '''''Specify the Video/TV signal format.
        '''''
        ''''' Valid Values:
        '''''
        ''''' NISCOPE_VAL_NTSC  (1)
        ''''' NISCOPE_VAL_PAL   (2) 
        ''''' NISCOPE_VAL_SECAM (3) 
        '''''</param>
        '''''<param name="Event">
        '''''Video/TV event to trigger off of.
        '''''
        '''''  Valid Values:
        '''''
        '''''  NISCOPE_VAL_TV_EVENT_FIELD1 (1) - trigger on field 1 of the signal
        '''''  NISCOPE_VAL_TV_EVENT_FIELD2 (2) - trigger on field 2 of the signal
        '''''  NISCOPE_VAL_TV_EVENT_ANY_FIELD (3) - trigger on the first field acquired
        '''''  NISCOPE_VAL_TV_EVENT_ANY_LINE (4) - trigger on the first line acquired
        '''''  NISCOPE_VAL_TV_EVENT_LINE_NUMBER (5) - trigger on a specific line of a video signal.  Valid values vary depending on the signal format configured.
        '''''</param>
        '''''<param name="Polarity">
        '''''Specify the polarity of the video signal to trigger off of.
        '''''  
        ''''' Valid Values:
        '''''
        ''''' NISCOPE_VAL_TV_POSITIVE (1)
        ''''' NISCOPE_VAL_TV_NEGATIVE (2)
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ConfigureTVTriggerSource(ByVal Source As String, ByVal Signal_Format As Integer, ByVal [Event] As Integer, ByVal Polarity As Integer) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureTVTriggerSource(Me._handle, Source, Signal_Format, [Event], Polarity)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Sends a command to trigger the digitizer. You can configure the type of software trigger to send with the Trigger Name property.  Call this function after you call niScope_ConfigureTriggerSoftware. 
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function SendSWTrigger() As Integer
            Dim pInvokeResult As Integer = PInvoke.SendSWTrigger(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Clears the list of current interchange warnings.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ClearInterchangeWarnings() As Integer
            Dim pInvokeResult As Integer = PInvoke.ClearInterchangeWarnings(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Returns the interchangeability warnings associated with the IVI session. It retrieves and clears the oldest instance in which the class driver recorded an interchangeability warning. Interchangeability warnings indicate that using your application with a different instrument might cause different behavior. 
        '''''Use this function to retrieve interchangeability warnings. The driver performs interchangeability checking when NISCOPE_ATTR_INTERCHANGE_CHECK is set to VI_TRUE. The function returns an empty string in the Interchange Warning parameter if no interchangeability warnings remain for the session. 
        '''''In general, the instrument driver generates interchangeability warnings when an attribute that affects the behavior of the instrument is in a state that you did not specify.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Buffer_Size">
        '''''Passes the number of bytes in the ViChar array you specify for the Description parameter. 
        '''''If the error description, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies BufferSize - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
        '''''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. 
        '''''If you pass 0, you can pass VI_NULL for the Description buffer parameter. 
        '''''
        '''''</param>
        '''''<param name="Interchange_Warning">
        '''''Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string. The buffer must contain at least as many elements as the value you specify with the Buffer Size parameter. 
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function GetNextInterchangeWarning(ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetNextInterchangeWarning(Me._handle, Buffer_Size, Interchange_Warning)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order. To do so requires ensuring that each test module completely configures the state of each instrument it uses. 
        '''''
        '''''If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module. 
        '''''If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change. 
        '''''
        '''''This change in behavior is generally instrument-specific and represents an interchangeability problem. You can use this function to test for such cases. After you call this function, the interchangeability checking algorithms in the specific driver ignore all previous configuration operations. 
        '''''By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules. 
        '''''
        '''''This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings. If you want to guarantee that niScope_GetNextInterchangeWarning only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings. 
        '''''
        '''''You can clear the interchangeability warnings list by repeatedly calling niScope_GetNextInterchangeWarning until no more interchangeability warnings are returned. If you are not interested in the content of those warnings, you can call niScope_ClearInterchangeWarnings.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ResetInterchangeCheck() As Integer
            Dim pInvokeResult As Integer = PInvoke.ResetInterchangeCheck(Me._handle)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Returns the waveform from a previously initiated acquisition that the digitizer  acquires for the channel you specify.  
        '''''
        '''''niScope_InitiateAcquisition starts an acquisition on the channels that you enable with niScope_ConfigureVertical.  The digitizer acquires waveforms for the enabled channels concurrently.  You use niScope_AcquisitionStatus to determine when the acquisition is complete.  You must call this function separately for each enabled channel to obtain the waveforms.
        '''''
        '''''You can call niScope_ReadWaveform instead of niScope_InitiateAcquisition.  niScope_ReadWaveform starts an acquisition on all enabled channels, waits for the acquisition to complete, and returns the waveform for the channel you specify.  Call this function to obtain the waveforms for each of the remaining channels.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel">
        '''''Pass the channel name you want to acquire data from.
        '''''
        '''''Valid Channel Names: 
        '''''"0".."n-1", n is the number of channels on the NI-SCOPE device
        '''''
        '''''</param>
        '''''<param name="Waveform_Size">
        '''''The number of elements to insert into the Waveform Array.
        '''''
        '''''</param>
        '''''<param name="Waveform">
        '''''Returns the waveform that the digitizer acquires. 
        '''''
        '''''Units: volts
        '''''
        '''''Notes:
        '''''If the digitizer cannot sample a point in the waveform, this function returns an error.
        '''''</param>
        '''''<param name="Actual_Points">
        '''''Indicates the actual number of points the function placed in the Waveform Array.
        '''''
        '''''</param>
        '''''<param name="Initial_X">
        '''''Indicates the time of the first point in the Waveform Array.  The time is relative to the Reference Position.  
        '''''
        '''''Units: seconds  
        '''''
        '''''For example, if the digitizer acquires the first point in the Waveform Array 1 second before the trigger, this parameter returns the value -1.0.  If the acquisition of the first point occurs at the same time as the trigger, this parameter returns the value 0.0.
        '''''</param>
        '''''<param name="X_Increment">
        '''''Indicates the length of time between points in the Waveform Array.  
        '''''
        '''''Units: seconds
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function FetchWaveform(ByVal Channel As String, ByVal Waveform_Size As Integer, ByVal Waveform() As Double, ByRef Actual_Points As Integer, ByRef Initial_X As Double, ByRef X_Increment As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchWaveform(Me._handle, Channel, Waveform_Size, Waveform, Actual_Points, Initial_X, X_Increment)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Determines whether a value you pass from the waveform array is invalid. After the read and fetch waveform functions execute, each element in the waveform array contains either a voltage or a value indicating that the instrument could not sample a voltange.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Element_Value">
        '''''Pass one of the values from the waveform array returned by the read and fetch waveform functions.
        '''''</param>
        '''''<param name="Is_Invalid">
        '''''Returns whether the element value is a valid voltage or a value indicating that the digitizer could not sample a voltage.
        '''''
        '''''Return values:
        '''''   VI_TRUE : The element value indicates that the instrument could not sample the voltage.
        '''''
        '''''   VI_FALSE : The element value is a valid voltage.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function IsInvalidWfmElement(ByVal Element_Value As Double, ByRef Is_Invalid As Boolean) As Integer
            Dim Is_InvalidAsUShort As UShort
            Dim pInvokeResult As Integer = PInvoke.IsInvalidWfmElement(Me._handle, Element_Value, Is_InvalidAsUShort)
            Is_Invalid = System.Convert.ToBoolean(Is_InvalidAsUShort)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Initiates an acquisition on the channels that you enable with  niScope_ConfigureVertical. This  function then waits for the acquisition to complete and returns the waveform for the channel you specify. Call  niScope_FetchWaveform to obtain the waveforms for each of the remaining enabled channels without initiating another acquisition. 
        '''''
        '''''Use niScope_ActualRecordLength to determine the required size for the WaveformArray. 
        '''''
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel">
        '''''Pass the channel name you want to acquire data from.
        '''''
        '''''Valid Channel Names: 
        '''''"0".."n-1", n is the number of channels on the NI-SCOPE device
        '''''
        '''''</param>
        '''''<param name="Waveform_Size">
        '''''The number of elements to insert into the Waveform Array.
        '''''
        '''''
        '''''
        '''''</param>
        '''''<param name="MaxTime">
        '''''Pass the maximum length of time in which to allow the read waveform operation to complete.    
        '''''
        '''''If the operation does not complete within this time interval, the function returns the NISCOPE_ERROR_MAX_TIME_EXCEEDED error code.  When this occurs, you can call niScope_Abort to cancel the read waveform operation and return the digitizer to the idle state.
        '''''
        '''''Units: milliseconds
        '''''
        '''''Other defined values:
        '''''NISCOPE_VAL_MAX_TIME_IMMEDIATE    
        '''''NISCOPE_VAL_MAX_TIME_INFINITE
        '''''
        '''''Notes:
        '''''The Maximum Time parameter affects only this function.  It has no effect on other timeout parameters or attributes.
        '''''</param>
        '''''<param name="Waveform">
        '''''Returns the waveform that the digitizer acquires.
        '''''Units: volts
        '''''
        '''''Note If the digitizer cannot sample a point in the waveform, this function returns an error.
        '''''</param>
        '''''<param name="Actual_Points">
        '''''Indicates the actual number of points the function placed in the Waveform Array.
        '''''
        '''''</param>
        '''''<param name="Initial__X">
        '''''Indicates the time of the first point in the Waveform Array.  The time is relative to the Reference Position.  
        '''''
        '''''Units: seconds  
        '''''
        '''''For example, if the digitizer acquires the first point in the Waveform Array 1 second before the trigger, this parameter returns the value -1.0.  If the acquisition of the first point occurs at the same time as the trigger, this parameter returns the value 0.0.
        '''''</param>
        '''''<param name="X_Increment">
        '''''Indicates the length of time between points in the Waveform Array.  
        '''''
        '''''Units: seconds
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ReadWaveform(ByVal Channel As String, ByVal Waveform_Size As Integer, ByVal MaxTime As Integer, ByVal Waveform() As Double, ByRef Actual_Points As Integer, ByRef Initial__X As Double, ByRef X_Increment As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadWaveform(Me._handle, Channel, Waveform_Size, MaxTime, Waveform, Actual_Points, Initial__X, X_Increment)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Fetches a waveform measurement from a specific channel from a previously initiated waveform acquisition. You specify a particular measurement type, such as rise time, frequency, and voltage peak-to-peak. 
        '''''
        '''''Note  You can use niScope_ReadWaveformMeasurement instead of this function. niScope_ReadWaveformMeasurement starts an acquisition on all enabled channels, waits for the acquisition to complete, obtains a waveform measurement on the specified channel, and returns the waveform for the specified channel. Call this function separately to obtain any other waveform measurements on a specific channel. 
        '''''
        '''''Configure the appropriate reference levels before calling this function. You can configure the low, mid, and high references by  setting the following attributes: 
        '''''
        '''''-NISCOPE_ATTR_MEAS_HIGH_REF 
        '''''-NISCOPE_ATTR_MEAS_LOW_REF 
        '''''-NISCOPE_ATTR_MEAS_MID_REF 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel">
        '''''The channel to read the waveform from, such as "0" or "1".
        '''''
        '''''</param>
        '''''<param name="Meas_Function">
        '''''Characteristic of the acquired waveform to be measured
        '''''</param>
        '''''<param name="Measurement">
        '''''The measured value
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function FetchWaveformMeasurement(ByVal Channel As String, ByVal Meas_Function As Integer, ByRef Measurement As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.FetchWaveformMeasurement(Me._handle, Channel, Meas_Function, Measurement)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Configures the reference levels for all channels of the digitizer. The levels may be set on a per channel basis by setting  NISCOPE_ATTR_MEAS_CHAN_HIGH_REF_LEVEL, NISCOPE_ATTR_MEAS_CHAN_LOW_REF_LEVEL, and NISCOPE_ATTR_MEAS_CHAN_MID_REF_LEVEL 
        '''''
        '''''This function configures the reference levels for waveform measurements. Call this function before calling niScope_FetchMeasurement to take a rise time, fall time, width negative, width positive, duty cycle negative, or duty cycle positive measurement.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The instrument handle obtained from niScope_init
        '''''</param>
        '''''<param name="Low">
        '''''Pass the low reference you want the digitizer to use for waveform measurements.
        '''''
        '''''Units: Either a percentage or voltage based on NISCOPE_ATTR_MEAS_REF_LEVEL_UNITS. A percentage is calculated with the voltage low and voltage high measurements representing 0% and 100% respectively.
        '''''
        '''''Default Value:  10.0
        '''''</param>
        '''''<param name="Mid">
        '''''Pass the mid reference you want the digitizer to use for waveform measurements.
        '''''
        '''''Units: Either a percentage or voltage based on NISCOPE_ATTR_MEAS_REF_LEVEL_UNITS. A percentage is calculated with the voltage low and voltage high measurements representing 0% and 100% respectively.
        '''''
        '''''Default Value:  50.0
        '''''</param>
        '''''<param name="High">
        '''''Pass the high reference you want the digitizer to use for waveform measurements.
        '''''
        '''''Units: Either a percentage or voltage based on NISCOPE_ATTR_MEAS_REF_LEVEL_UNITS. A percentage is calculated with the voltage low and voltage high measurements representing 0% and 100% respectively.
        '''''
        '''''Default Value:  90.0
        '''''</param>
        '''''<returns>
        '''''Call niScope_errorHandler to get a text description of the error code.
        '''''</returns>
        Public Function ConfigureRefLevels(ByVal Low As Double, ByVal Mid As Double, ByVal High As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ConfigureRefLevels(Me._handle, Low, Mid, High)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Initiates a new waveform acquisition and returns a specified waveform measurement from a specific channel. 
        '''''
        '''''This function initiates an acquisition on the channels that you enable with the niScope_ConfigureVertical function. It then waits for the acquisition to complete, obtains a waveform measurement on the channel you specify, and returns the measurement value. You specify a particular measurement type, such as rise time, frequency, or voltage peak-to-peak. 
        '''''
        '''''You can call the niScope_FetchWaveformMeasurement function separately to obtain any other waveform measurement on a specific channel without initiating another acquisition. 
        '''''
        '''''You must configure the appropriate reference levels before calling this function. Configure the low, mid, and high references by calling niScope_ConfigureRefLevels or by setting the following attributes: 
        '''''
        '''''NISCOPE_ATTR_MEAS_HIGH_REF 
        '''''NISCOPE_ATTR_MEAS_LOW_REF 
        '''''NISCOPE_ATTR_MEAS_MID_REF 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Channel">
        '''''The channel to read the waveform from, such as "0" or "1".
        '''''
        '''''</param>
        '''''<param name="Meas_Function">
        '''''The scalar measurement to perform
        '''''</param>
        '''''<param name="Max_Time">
        '''''Pass the maximum length of time in which to allow the read waveform operation to complete.    
        '''''
        '''''If the operation does not complete within this time interval, the VI returns the NISCOPE_ERROR_MAX_TIME_EXCEEDED error code.  When this occurs, you can call niScope_Abort to cancel the read waveform operation and return the digitizer to the idle state.
        '''''
        '''''Units: milliseconds
        '''''
        '''''Note The Max Time parameter affects only this function.  It has no effect on other timeout parameters or properties.
        '''''</param>
        '''''<param name="Measurement">
        '''''The measured value
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function ReadWaveformMeasurement(ByVal Channel As String, ByVal Meas_Function As Integer, ByVal Max_Time As Integer, ByRef Measurement As Double) As Integer
            Dim pInvokeResult As Integer = PInvoke.ReadWaveformMeasurement(Me._handle, Channel, Meas_Function, Max_Time, Measurement)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Returns the coercion information associated with the IVI session. This function retrieves and clears the oldest instance in which the instrument driver coerced a value you specified to another value. 
        '''''
        '''''If you set NISCOPE_ATTR_RECORD_COERCIONS to VI_TRUE, NI-SCOPE keeps a list of all coercions it makes on ViInt32 or ViReal64 values that you pass to instrument driver functions. Use this function to retrieve information from that list.
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Buffer_Size">
        '''''Passes the number of bytes in the ViChar array you specify for the Description parameter. 
        '''''If the error description, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies BufferSize - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
        '''''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. 
        '''''If you pass 0, you can pass VI_NULL for the Description buffer parameter. 
        '''''
        '''''</param>
        '''''<param name="Record">
        '''''Returns the next coercion record for the IVI session. 
        '''''If there are no coercions records, the function returns an empty string. The buffer must contain at least as many elements as the value you specify with the Buffer Size parameter.
        '''''
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function GetNextCoercionRecord(ByVal Buffer_Size As Integer, ByVal Record As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetNextCoercionRecord(Me._handle, Buffer_Size, Record)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Reads an error code and message from the error queue. National Instruments digitizers do not contain an error queue. Errors are reported as they occur. Therefore, this function does not detect errors; 
        '''''
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Err_Code">
        '''''Returns the error code for the session or execution thread. If you pass 0 for the Buffer Size, you can pass VI_NULL for this parameter.
        '''''</param>
        '''''<param name="Err_Message">
        '''''Formats the error code into a user-readable message string. Note: The array must contain at least 256 elements ViChar[256].
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function error_query(ByRef Err_Code As Integer, ByVal Err_Message As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.error_query(Me._handle, Err_Code, Err_Message)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        '''''<summary>
        '''''This function is included for compliance with the IviScope Class Specification.
        '''''
        '''''Returns the channel string that is in the channel table at an index you specify. Not applicable to National Instruments digitizers.
        '''''</summary>
        '''''<param name="Instrument_Handle">
        '''''The Instrument Handle that you obtain from niScope_init.  The handle identifies a particular instrument's session.
        '''''</param>
        '''''<param name="Index">
        '''''A 1-based index into the channel table.
        '''''</param>
        '''''<param name="Buffer_Size">
        '''''Passes the number of bytes in the ViChar array you specify for the Description parameter. 
        '''''If the error description, including the terminating NULL byte, contains more bytes than you indicate in this parameter, the function copies BufferSize - 1 bytes into the buffer, places an ASCII NULL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value. For example, if the value is "123456" and the Buffer Size is 4, the function places "123" into the buffer and returns 7. 
        '''''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value. 
        '''''If you pass 0, you can pass VI_NULL for the Description buffer parameter. 
        '''''
        '''''</param>
        '''''<param name="Channel_String">
        '''''Returns the channel string that is in the channel table at the index you specify. Do not modify the contents of the channel string.
        '''''</param>
        '''''<returns>
        '''''Returns the status of the function.
        '''''
        '''''To obtain a text description of the status code call niScope_errorHandler.
        '''''</returns>
        Public Function GetChannelName(ByVal Index As Integer, ByVal Buffer_Size As Integer, ByVal Channel_String As System.Text.StringBuilder) As Integer
            Dim pInvokeResult As Integer = PInvoke.GetChannelName(Me._handle, Index, Buffer_Size, Channel_String)
            PInvoke.TestForError(Me._handle, pInvokeResult)
            Return pInvokeResult
        End Function

        Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
            Me.Dispose(True)
            System.GC.SuppressFinalize(Me)
        End Sub

        Private Overloads Sub Dispose(ByVal disposing As Boolean)
            If (Me._disposed = False) Then
                PInvoke.close(Me._handle)
                Me._handle = System.IntPtr.Zero
            End If
            Me._disposed = True
        End Sub

        Protected Overrides Sub Finalize()
            Me.Dispose(False)
        End Sub

        Public Overloads Sub SetInt32(ByVal propertyId As niScopeProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Integer)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetInt32(ByVal propertyId As niScopeProperties, ByVal val As Integer)
            Me.SetInt32(propertyId, "", val)
        End Sub

        Public Overloads Function GetInt32(ByVal propertyId As niScopeProperties, ByVal repeatedCapabilityOrChannel As String) As Integer
            Dim val As Integer
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return val
        End Function

        Public Overloads Function GetInt32(ByVal propertyId As niScopeProperties) As Integer
            Return Me.GetInt32(propertyId, "")
        End Function

        Public Overloads Sub SetDouble(ByVal propertyId As niScopeProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Double)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetDouble(ByVal propertyId As niScopeProperties, ByVal val As Double)
            Me.SetDouble(propertyId, "", val)
        End Sub

        Public Overloads Function GetDouble(ByVal propertyId As niScopeProperties, ByVal repeatedCapabilityOrChannel As String) As Double
            Dim val As Double
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return val
        End Function

        Public Overloads Function GetDouble(ByVal propertyId As niScopeProperties) As Double
            Return Me.GetDouble(propertyId, "")
        End Function

        Public Overloads Sub SetBoolean(ByVal propertyId As niScopeProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Boolean)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), System.Convert.ToUInt16(val)))
        End Sub

        Public Overloads Sub SetBoolean(ByVal propertyId As niScopeProperties, ByVal val As Boolean)
            Me.SetBoolean(propertyId, "", val)
        End Sub

        Public Overloads Function GetBoolean(ByVal propertyId As niScopeProperties, ByVal repeatedCapabilityOrChannel As String) As Boolean
            Dim val As UShort
            PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
            Return System.Convert.ToBoolean(val)
        End Function

        Public Overloads Function GetBoolean(ByVal propertyId As niScopeProperties) As Boolean
            Return Me.GetBoolean(propertyId, "")
        End Function

        Public Overloads Sub SetString(ByVal propertyId As niScopeProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As String)
            PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), val))
        End Sub

        Public Overloads Sub SetString(ByVal propertyId As niScopeProperties, ByVal val As String)
            Me.SetString(propertyId, "", val)
        End Sub

        Public Overloads Function GetString(ByVal propertyId As niScopeProperties, ByVal repeatedCapabilityOrChannel As String) As String
            Dim newVal As System.Text.StringBuilder = New System.Text.StringBuilder(512)
            Dim size As Integer = PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), 512, newVal)
            If (size < 0) Then
                PInvoke.ThrowError(Me._handle, size)
            Else
                If (size > 0) Then
                    newVal.Capacity = size
                    PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId, Integer), size, newVal))
                End If
            End If
            Return newVal.ToString
        End Function

        Public Overloads Function GetString(ByVal propertyId As niScopeProperties) As String
            Return Me.GetString(propertyId, "")
        End Function

        Private Class PInvoke

            <DllImport("niScope_32.dll", EntryPoint:="niScope_init", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function init(ByVal Resource_Name As String, ByVal ID_Query As UShort, ByVal Reset_Device As UShort, ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_InitWithOptions", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function InitWithOptions(ByVal Resource_Name As String, ByVal ID_Query As UShort, ByVal Reset_Device As UShort, ByVal Option_String As String, ByRef Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_AutoSetup", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function AutoSetup(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureAcquisition", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureAcquisition(ByVal Instrument_Handle As System.IntPtr, ByVal Acquisition_Type As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureHorizontalTiming", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureHorizontalTiming(ByVal Instrument_Handle As System.IntPtr, ByVal Min_Sample_Rate As Double, ByVal Min_Num_Pts As Integer, ByVal Ref_Position As Double, ByVal Num_Records As Integer, ByVal Enforce_Realtime As UShort) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureChanCharacteristics", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureChanCharacteristics(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Input_Impedance As Double, ByVal Max_Input_Frequency As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureVertical", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureVertical(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Range As Double, ByVal Offset As Double, ByVal Coupling As Integer, ByVal Probe_Attenuation As Double, ByVal Enabled As UShort) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ActualRecordLength", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ActualRecordLength(ByVal Instrument_Handle As System.IntPtr, ByRef Record_Length As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ActualNumWfms", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ActualNumWfms(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByRef Num_Wfms As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ActualMeasWfmSize", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ActualMeasWfmSize(ByVal Instrument_Handle As System.IntPtr, ByVal Array_Meas_Function As Integer, ByRef Meas_Waveform_Size As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_SampleMode", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SampleMode(ByVal Instrument_Handle As System.IntPtr, ByRef Sample_Mode As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_SampleRate", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SampleRate(ByVal Instrument_Handle As System.IntPtr, ByRef Sample_Rate As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTriggerDigital", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerDigital(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Source As String, ByVal Slope As Integer, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTriggerEdge", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerEdge(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Source As String, ByVal Level As Double, ByVal Slope As Integer, ByVal Trigger_Coupling As Integer, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTriggerVideo", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerVideo(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Source As String, ByVal Enable_DC_Restore As UShort, ByVal Signal_Format As Integer, ByVal [Event] As Integer, ByVal Line_Number As Integer, ByVal Polarity As Integer, ByVal Trigger_Coupling As Integer, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTriggerHysteresis", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerHysteresis(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Source As String, ByVal Level As Double, ByVal Hysteresis As Double, ByVal Slope As Integer, ByVal Trigger_Coupling As Integer, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTriggerImmediate", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerImmediate(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTriggerSoftware", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerSoftware(ByVal Instrument_Handle As System.IntPtr, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTriggerWindow", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerWindow(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Source As String, ByVal Low_Level As Double, ByVal High_Level As Double, ByVal Window_Mode As Integer, ByVal Trigger_Coupling As Integer, ByVal Holdoff As Double, ByVal Delay As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_SendSoftwareTriggerEdge", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SendSoftwareTriggerEdge(ByVal Instrument_Handle As System.IntPtr, ByVal Which_Trigger As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_AdjustSampleClockRelativeDelay", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function AdjustSampleClockRelativeDelay(ByVal Instrument_Handle As System.IntPtr, ByVal Delay As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureClock", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureClock(ByVal Instrument_Handle As System.IntPtr, ByVal Input_Clock_Source As String, ByVal Output_Clock_Source As String, ByVal Clock_Sync_Pulse_Source As String, ByVal Master_Enabled As UShort) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTriggerOutput", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerOutput(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Event As Integer, ByVal Trigger_Output As String) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ExportSignal", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ExportSignal(ByVal Instrument_Handle As System.IntPtr, ByVal Signal As Integer, ByVal Signal_Identifier As String, ByVal Output_Terminal As String) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureEqualizationFilterCoefficients", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureEqualizationFilterCoefficients(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Number_Of_Coefficients As Integer, <[In](), Out()> ByVal Coefficients As Double()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetFrequencyResponse", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetFrequencyResponse(ByVal vi As System.IntPtr, ByVal channel As String, ByVal bufferSize As Integer, ByVal frequencies As Double(), ByVal amplitudes As Double(), ByVal phases As Double(), ByRef numberOfFrequencies As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_Abort", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Abort(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_AcquisitionStatus", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function AcquisitionStatus(ByVal Instrument_Handle As System.IntPtr, ByRef Acquisition_Status As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_Commit", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Commit(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_Fetch", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Fetch(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, <[In](), Out()> ByVal Wfm As Double(), <[In](), Out()> ByVal Wfm_Info As niScopeWfmInfo()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_FetchComplex", CallingConvention:=CallingConvention.StdCall)> _
                        Public Shared Function FetchComplex(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, <[In](), Out()> ByVal Wfm As niComplexNumber(), <[In](), Out()> ByVal Wfm_Info As niScopeWfmInfo()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_FetchComplexBinary16", CallingConvention:=CallingConvention.StdCall)> _
                        Public Shared Function FetchComplexBinary16(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, <[In](), Out()> ByVal Wfm As niComplexNumber16(), <[In](), Out()> ByVal Wfm_Info As niScopeWfmInfo()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_FetchBinary8", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function FetchBinary8(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, <[In](), Out()> ByVal Wfm As SByte(), <[In](), Out()> ByVal Wfm_Info As niScopeWfmInfo()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_FetchBinary16", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function FetchBinary16(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, <[In](), Out()> ByVal Wfm As Short(), <[In](), Out()> ByVal Wfm_Info As niScopeWfmInfo()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_FetchBinary32", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function FetchBinary32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, <[In](), Out()> ByVal Wfm As Integer(), <[In](), Out()> ByVal Wfm_Info As niScopeWfmInfo()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_InitiateAcquisition", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function InitiateAcquisition(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_Read", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Read(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Num_Samples As Integer, <[In](), Out()> ByVal Wfm As Double(), <[In](), Out()> ByVal Wfm_Info As niScopeWfmInfo()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_AddWaveformProcessing", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function AddWaveformProcessing(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Meas_Function As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ClearWaveformMeasurementStats", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ClearWaveformMeasurementStats(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Clearable_Measurement_Function As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ClearWaveformProcessing", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ClearWaveformProcessing(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_FetchArrayMeasurement", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function FetchArrayMeasurement(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Array_Meas_Function As Integer, ByVal Meas_Wfm_Size As Integer, <[In](), Out()> ByVal Meas_Wfm As Double(), <[In](), Out()> ByVal Wfm_Info As niScopeWfmInfo()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_FetchMeasurement", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function FetchMeasurement(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Scalar_Meas_Function As Integer, <[In](), Out()> ByVal Result As Double()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_FetchMeasurementStats", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function FetchMeasurementStats(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Scalar_Meas_Function As Integer, <[In](), Out()> ByVal Result As Double(), <[In](), Out()> ByVal Mean As Double(), <[In](), Out()> ByVal Stdev As Double(), <[In](), Out()> ByVal Min As Double(), <[In](), Out()> ByVal Max As Double(), <[In](), Out()> ByVal Num_In_Stats As Integer()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ReadMeasurement", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ReadMeasurement(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Timeout As Double, ByVal Scalar_Meas_Function As Integer, <[In](), Out()> ByVal Result As Double()) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_CalSelfCalibrate", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function CalSelfCalibrate(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal [Option] As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ResetDevice", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ResetDevice(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_Disable", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function Disable(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ProbeCompensationSignalStart", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ProbeCompensationSignalStart(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ProbeCompensationSignalStop", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ProbeCompensationSignalStop(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_reset", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function reset(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ResetWithDefaults", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ResetWithDefaults(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_revision_query", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function revision_query(ByVal Instrument_Handle As System.IntPtr, ByVal Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_self_test", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function self_test(ByVal Instrument_Handle As System.IntPtr, ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_errorHandler", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function errorHandler(ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Source As System.Text.StringBuilder, ByVal Error_Description As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetErrorMessage", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetErrorMessage(ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Buffer_Size As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureAcquisitionRecord", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureAcquisitionRecord(ByVal Instrument_Handle As System.IntPtr, ByVal Time_per_Record As Double, ByVal Min_Num_Points As Integer, ByVal Acquisition_Start_Time As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureChannel", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureChannel(ByVal Instrument_Handle As System.IntPtr, ByVal Channel As String, ByVal Range As Double, ByVal Offset As Double, ByVal Coupling As Integer, ByVal Probe_Attenuation As Double, ByVal Enabled As UShort) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureEdgeTriggerSource", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureEdgeTriggerSource(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Level As Double, ByVal Slope As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTrigger(ByVal Instrument_Handle As System.IntPtr, ByVal Trigger_Type As Integer, ByVal Holdoff As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTriggerCoupling", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTriggerCoupling(ByVal Instrument_Handle As System.IntPtr, ByVal Coupling As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTVTriggerLineNumber", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTVTriggerLineNumber(ByVal Instrument_Handle As System.IntPtr, ByVal Line_Number As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureTVTriggerSource", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureTVTriggerSource(ByVal Instrument_Handle As System.IntPtr, ByVal Source As String, ByVal Signal_Format As Integer, ByVal [Event] As Integer, ByVal Polarity As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_SendSWTrigger", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SendSWTrigger(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ClearInterchangeWarnings", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ClearInterchangeWarnings(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetNextInterchangeWarning", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetNextInterchangeWarning(ByVal Instrument_Handle As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ResetInterchangeCheck", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ResetInterchangeCheck(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_FetchWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function FetchWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Channel As String, ByVal Waveform_Size As Integer, <[In](), Out()> ByVal Waveform As Double(), ByRef Actual_Points As Integer, ByRef Initial_X As Double, ByRef X_Increment As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_IsInvalidWfmElement", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function IsInvalidWfmElement(ByVal Instrument_Handle As System.IntPtr, ByVal Element_Value As Double, ByRef Is_Invalid As UShort) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ReadWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ReadWaveform(ByVal Instrument_Handle As System.IntPtr, ByVal Channel As String, ByVal Waveform_Size As Integer, ByVal MaxTime As Integer, <[In](), Out()> ByVal Waveform As Double(), ByRef Actual_Points As Integer, ByRef Initial__X As Double, ByRef X_Increment As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_FetchWaveformMeasurement", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function FetchWaveformMeasurement(ByVal Instrument_Handle As System.IntPtr, ByVal Channel As String, ByVal Meas_Function As Integer, ByRef Measurement As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ConfigureRefLevels", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ConfigureRefLevels(ByVal Instrument_Handle As System.IntPtr, ByVal Low As Double, ByVal Mid As Double, ByVal High As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_ReadWaveformMeasurement", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function ReadWaveformMeasurement(ByVal Instrument_Handle As System.IntPtr, ByVal Channel As String, ByVal Meas_Function As Integer, ByVal Max_Time As Integer, ByRef Measurement As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetNextCoercionRecord", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetNextCoercionRecord(ByVal Instrument_Handle As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Record As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_error_query", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function error_query(ByVal Instrument_Handle As System.IntPtr, ByRef Err_Code As Integer, ByVal Err_Message As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetChannelName", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetChannelName(ByVal Instrument_Handle As System.IntPtr, ByVal Index As Integer, ByVal Buffer_Size As Integer, ByVal Channel_String As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_close", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function close(ByVal Instrument_Handle As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_error_message", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function error_message(ByVal Instrument_Handle As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message_2 As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByRef Value As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByRef Value As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Buf_Size As Integer, ByVal Value As System.Text.StringBuilder) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByRef Value As UShort) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByRef Value As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_SetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViInt32(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Value As Integer) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_SetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViReal64(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Value As Double) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_SetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViString(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Value As String) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_SetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViBoolean(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Value As UShort) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_SetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function SetAttributeViSession(ByVal Instrument_Handle As System.IntPtr, ByVal Channel_List As String, ByVal Attribute_ID As Integer, ByVal Value As System.IntPtr) As Integer
            End Function

            <DllImport("niScope_32.dll", EntryPoint:="niScope_GetError", CallingConvention:=CallingConvention.StdCall)> _
            Public Shared Function GetError(ByVal Instrument_Handle As System.IntPtr, ByRef Error_Code As Integer, ByVal Buffer_Size As Integer, ByVal Description As System.Text.StringBuilder) As Integer
            End Function


            Public Shared Function TestForError(ByVal handle As System.IntPtr, ByVal status As Integer) As Integer
                If (status < 0) Then
                    PInvoke.ThrowError(handle, status)
                End If
                Return status
            End Function

            Public Shared Function ThrowError(ByVal handle As System.IntPtr, ByVal code As Integer) As Integer
                Dim status As Integer
                Dim size As Integer = PInvoke.GetError(handle, status, 0, Nothing)
                Dim msg As System.Text.StringBuilder = New System.Text.StringBuilder
                If (size >= 0) Then
                    msg.Capacity = size
                    PInvoke.GetError(handle, status, size, msg)
                End If
                Throw New System.Runtime.InteropServices.ExternalException(msg.ToString, code)
            End Function
        End Class
    End Class

    Public Class niScopeConstants

        Public Const Normal As Integer = 0

        Public Const Flexres As Integer = 1001

        Public Const Ddc As Integer = 1002

        Public Const _1MegOhm As Double = 1000000

        Public Const _50Ohms As Double = 50

        Public Const Ac As Integer = 0

        Public Const Dc As Integer = 1

        Public Const Gnd As Integer = 2

        Public Const NoMeasurement As Integer = 4000

        Public Const LastAcqHistogram As Integer = 4001

        Public Const MultiAcqVoltageHistogram As Integer = 4004

        Public Const MultiAcqTimeHistogram As Integer = 4005

        Public Const MultiAcqAverage As Integer = 4016

        Public Const FftPhaseSpectrum As Integer = 4002

        Public Const FftAmpSpectrumVoltsRms As Integer = 4003

        Public Const FftAmpSpectrumDb As Integer = 4019

        Public Const PolynomialInterpolation As Integer = 4011

        Public Const ArrayIntegral As Integer = 4006

        Public Const Derivative As Integer = 4007

        Public Const Inverse As Integer = 4008

        Public Const MultiplyChannels As Integer = 4012

        Public Const AddChannels As Integer = 4013

        Public Const SubtractChannels As Integer = 4014

        Public Const DivideChannels As Integer = 4015

        Public Const ArrayOffset As Integer = 4025

        Public Const ArrayGain As Integer = 4026

        Public Const TriangleWindow As Integer = 4023

        Public Const BlackmanWindow As Integer = 4024

        Public Const HammingWindow As Integer = 4020

        Public Const HanningWindow As Integer = 4009

        Public Const FlatTopWindow As Integer = 4010

        Public Const ButterworthFilter As Integer = 4017

        Public Const ChebyshevFilter As Integer = 4018

        Public Const BesselFilter As Integer = 4022

        Public Const WindowedFirFilter As Integer = 4021

        Public Const Positive As Integer = 1

        Public Const Negative As Integer = 0

        Public Const Rtsi0 As String = "VAL_RTSI_0"

        Public Const Rtsi1 As String = "VAL_RTSI_1"

        Public Const Rtsi2 As String = "VAL_RTSI_2"

        Public Const Rtsi3 As String = "VAL_RTSI_3"

        Public Const Rtsi4 As String = "VAL_RTSI_4"

        Public Const Rtsi5 As String = "VAL_RTSI_5"

        Public Const Rtsi6 As String = "VAL_RTSI_6"

        Public Const Pfi0 As String = "VAL_PFI_0"

        Public Const Pfi1 As String = "VAL_PFI_1"

        Public Const Pfi2 As String = "VAL_PFI_2"

        Public Const PxiStar As String = "VAL_PXI_STAR"

        Public Const HfReject As Integer = 3

        Public Const LfReject As Integer = 4

        Public Const AcPlusHfReject As Integer = 1001

        Public Const External As String = "VAL_EXTERNAL"

        Public Const Ntsc As Integer = 1

        Public Const Pal As Integer = 2

        Public Const Secam As Integer = 3

        Public Const MPal As Integer = 1001

        Public Const _480i5994FieldsPerSecond As Integer = 1010

        Public Const _480i60FieldsPerSecond As Integer = 1011

        Public Const _480p5994FramesPerSecond As Integer = 1015

        Public Const _480p60FramesPerSecond As Integer = 1016

        Public Const _576i50FieldsPerSecond As Integer = 1020

        Public Const _576p50FramesPerSecond As Integer = 1025

        Public Const _720p50FramesPerSecond As Integer = 1031

        Public Const _720p5994FramesPerSecond As Integer = 1032

        Public Const _720p60FramesPerSecond As Integer = 1033

        Public Const _1080i50FieldsPerSecond As Integer = 1040

        Public Const _1080i5994FieldsPerSecond As Integer = 1041

        Public Const _1080i60FieldsPerSecond As Integer = 1042

        Public Const _1080p24FramesPerSecond As Integer = 1045

        Public Const TvPositive As Integer = 1

        Public Const TvNegative As Integer = 2

        Public Const TvEventField1 As Integer = 1

        Public Const TvEventField2 As Integer = 2

        Public Const TvEventAnyField As Integer = 3

        Public Const TvEventAnyLine As Integer = 4

        Public Const TvEventLineNumber As Integer = 5

        Public Const EnteringWindow As Integer = 0

        Public Const LeavingWindow As Integer = 1

        Public Const SoftwareTriggerStart As Integer = 0

        Public Const SoftwareTriggerReference As Integer = 2

        Public Const SoftwareTriggerArmReference As Integer = 1

        Public Const SoftwareTriggerAdvance As Integer = 3

        Public Const NoSource As String = "VAL_NO_SOURCE"

        Public Const RtsiClock As String = "VAL_RTSI_CLOCK"

        Public Const PxiClock = "VAL_PXI_CLK"

        Public Const PxiClock10 = "VAL_PXI_CLK10"

        Public Const PxiClock100 = "VAL_PXI_CLK100"

        Public Const ClkIn As String = "VAL_CLK_IN"

        Public Const ClkOut As String = "VAL_CLK_OUT"

        Public Const None As Integer = 0

        Public Const StartTriggerEvent As Integer = 2

        Public Const StopTriggerEvent As Integer = 1

        Public Const EndOfAcquisitionEvent As Integer = 3

        Public Const EndOfRecordEvent As Integer = 4

        Public Const Rtsi7 As String = "VAL_RTSI_7"

        Public Const StartTrigger As Integer = 2

        Public Const RefTrigger As Integer = 1

        Public Const AdvanceTrigger As Integer = 5

        Public Const ReadyForAdvanceEvent As Integer = 6

        Public Const ReadyForStartEvent As Integer = 7

        Public Const ReadyForRefEvent As Integer = 10

        Public Const RefClock As Integer = 100

        Public Const SampleClock As Integer = 101

        Public Const _5vOut As Integer = 13

        Public Const AllMeasurements As Integer = 10000

        Public Const Frequency As Integer = 2

        Public Const AverageFrequency As Integer = 1016

        Public Const FftFrequency As Integer = 1008

        Public Const Period As Integer = 3

        Public Const AveragePeriod As Integer = 1015

        Public Const RiseTime As Integer = 0

        Public Const FallTime As Integer = 1

        Public Const VoltageRms As Integer = 4

        Public Const VoltageCycleRms As Integer = 16

        Public Const AcEstimate As Integer = 1012

        Public Const FftAmplitude As Integer = 1009

        Public Const VoltageAverage As Integer = 10

        Public Const VoltageCycleAverage As Integer = 17

        Public Const DcEstimate As Integer = 1013

        Public Const VoltageMax As Integer = 6

        Public Const VoltageMin As Integer = 7

        Public Const VoltagePeakToPeak As Integer = 5

        Public Const VoltageHigh As Integer = 8

        Public Const VoltageLow As Integer = 9

        Public Const Amplitude As Integer = 15

        Public Const VoltageBase As Integer = 1006

        Public Const VoltageTop As Integer = 1007

        Public Const VoltageBaseToTop As Integer = 1017

        Public Const WidthNeg As Integer = 11

        Public Const WidthPos As Integer = 12

        Public Const DutyCycleNeg As Integer = 13

        Public Const DutyCyclePos As Integer = 14

        Public Const Overshoot As Integer = 18

        Public Const Preshoot As Integer = 19

        Public Const LowRefVolts As Integer = 1000

        Public Const MidRefVolts As Integer = 1001

        Public Const HighRefVolts As Integer = 1002

        Public Const Area As Integer = 1003

        Public Const CycleArea As Integer = 1004

        Public Const Integral As Integer = 1005

        Public Const RiseSlewRate As Integer = 1010

        Public Const FallSlewRate As Integer = 1011

        Public Const TimeDelay As Integer = 1014

        Public Const PhaseDelay As Integer = 1018

        Public Const VoltageHistogramMean As Integer = 2000

        Public Const VoltageHistogramStdev As Integer = 2001

        Public Const VoltageHistogramMedian As Integer = 2003

        Public Const VoltageHistogramMode As Integer = 2010

        Public Const VoltageHistogramHits As Integer = 2004

        Public Const VoltageHistogramNewHits As Integer = 2011

        Public Const VoltageHistogramMax As Integer = 2005

        Public Const VoltageHistogramMin As Integer = 2006

        Public Const VoltageHistogramPeakToPeak As Integer = 2002

        Public Const VoltageHistogramMeanPlusStdev As Integer = 2007

        Public Const VoltageHistogramMeanPlus2Stdev As Integer = 2008

        Public Const VoltageHistogramMeanPlus3Stdev As Integer = 2009

        Public Const TimeHistogramMean As Integer = 3000

        Public Const TimeHistogramStdev As Integer = 3001

        Public Const TimeHistogramMedian As Integer = 3003

        Public Const TimeHistogramMode As Integer = 3010

        Public Const TimeHistogramHits As Integer = 3004

        Public Const TimeHistogramNewHits As Integer = 3011

        Public Const TimeHistogramMax As Integer = 3005

        Public Const TimeHistogramMin As Integer = 3006

        Public Const TimeHistogramPeakToPeak As Integer = 3002

        Public Const TimeHistogramMeanPlusStdev As Integer = 3007

        Public Const TimeHistogramMeanPlus2Stdev As Integer = 3008

        Public Const TimeHistogramMeanPlus3Stdev As Integer = 3009

        Public Const SelfCalibration As Integer = 0

        Public Const RestoreFactoryCalibration As Integer = 2

        Public Const ImmediateTrigger As Integer = 6

        Public Const Edge As Integer = 1

        Public Const TvTrigger As Integer = 5

        Public Const RealTime As Integer = 0

        Public Const EquivalentTime As Integer = 1

        Public Const Start As Integer = 482

        Public Const Pretrigger As Integer = 477

        Public Const Trigger As Integer = 483

        Public Const ReadPointer As Integer = 388

        Public Const Now As Integer = 481

        Public Const _75Ohms As Double = 75

        Public Const SingleEnded As Integer = 0

        Public Const UnbalancedDifferential As Integer = 1

        Public Const Differential As Integer = 2

        Public Const _48TapStandard As Integer = 0

        Public Const _48TapHanning As Integer = 1

        Public Const _16TapHanning As Integer = 2

        Public Const _8TapHanning As Integer = 3

        Public Const RisExactNumAverages As Integer = 1

        Public Const RisMinNumAverages As Integer = 2

        Public Const RisIncomplete As Integer = 3

        Public Const RisLimitedBinWidth As Integer = 5

        Public Const EdgeTrigger As Integer = 1

        Public Const HysteresisTrigger As Integer = 1001

        Public Const DigitalTrigger As Integer = 1002

        Public Const WindowTrigger As Integer = 1003

        Public Const SoftwareTrigger As Integer = 1004

        Public Const Immediate As String = "VAL_IMMEDIATE"

        Public Const SwTrigFunc As String = "VAL_SW_TRIG_FUNC"

        Public Const NoTriggerMod As Integer = 1

        Public Const [Auto] As Integer = 2

        Public Const AnalogDetectionCircuit As Integer = 0

        Public Const DdcOutput As Integer = 1

        Public Const Symmetric As Integer = 0

        Public Const Asymmetric As Integer = 1

        Public Const Even As Integer = 0

        Public Const Odd As Integer = 1

        Public Const Phase As Integer = 0

        Public Const Magnitude As Integer = 1

        Public Const Resampler As Integer = 2

        Public Const Real As Integer = 0

        Public Const Complex As Integer = 1

        Public Const ErrorReportingError As Integer = 0

        Public Const ErrorReportingWarning As Integer = 1

        Public Const ErrorReportingDisabled As Integer = 2

        Public Const NoTriggerMode As Integer = 1

        Public Const AutoTrigger As Integer = 2

    End Class

    <StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential, Pack:=8)> _
    Public Structure niScopeWfmInfo

        Public AbsoluteInitialX As Double

        Public RelativeInitialX As Double

        Public XIncrement As Double

        Public ActualSamples As Integer

        Public Offset As Double

        Public Gain As Double

        Public Reserved1 As Double

        Public Reserved2 As Double
    End Structure

    <StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential, Pack:=8)> _
    Public Structure niComplexNumber

        Public Real As Double

        Public Imaginary As Double

    End Structure

    <StructLayout(System.Runtime.InteropServices.LayoutKind.Sequential, Pack:=2)> _
    Public Structure niComplexNumber16

        Public Real As Short

        Public Imaginary As Short

    End Structure

    Public Enum niScopeProperties

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        AcquisitionType = 1250101

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        SampleMode = 1250106

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        BinarySampleWidth = 1150005

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        Resolution = 1150102

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FetchRelativeTo = 1150077

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FetchOffset = 1150078

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FetchRecordNumber = 1150079

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FetchNumRecords = 1150080

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FetchMeasNumSamples = 1150081

        '''''<summary>
        '''''System.Double
        '''''</summary>
        PointsDone = 1150082

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        RecordsDone = 1150083

        '''''<summary>
        '''''System.Double
        '''''</summary>
        Backlog = 1150084

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        RisInAutoSetupEnable = 1150106

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DataTransferBlockSize = 1150316

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        ChannelEnabled = 1250005

        '''''<summary>
        '''''System.Double
        '''''</summary>
        ProbeAttenuation = 1250004

        '''''<summary>
        '''''System.Double
        '''''</summary>
        VerticalRange = 1250001

        '''''<summary>
        '''''System.Double
        '''''</summary>
        VerticalOffset = 1250002

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        VerticalCoupling = 1250003

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MaxInputFrequency = 1250006

        '''''<summary>
        '''''System.Double
        '''''</summary>
        InputImpedance = 1250103

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        ChannelTerminalConfiguration = 1150107

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        FlexFirAntialiasFilterType = 1150271

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DigitalGain = 1150307

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DigitalOffset = 1150308

        '''''<summary>
        '''''System.Double
        '''''</summary>
        AcquisitionStartTime = 1250109

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        HorzNumRecords = 1150001

        '''''<summary>
        '''''System.Double
        '''''</summary>
        HorzTimePerRecord = 1250007

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        HorzMinNumPts = 1250009

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        HorzRecordLength = 1250008

        '''''<summary>
        '''''System.Double
        '''''</summary>
        HorzRecordRefPosition = 1250011

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MinSampleRate = 1150009

        '''''<summary>
        '''''System.Double
        '''''</summary>
        HorzSampleRate = 1250010

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        HorzEnforceRealtime = 1150004

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        RefTrigTdcEnable = 1150096

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        AllowMoreRecordsThanMemory = 1150068

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        EnableTimeInterleavedSampling = 1150128

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        PollInterval = 1150100

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        RisNumAverages = 1150070

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        RisMethod = 1150071

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        _5102AdjustPretriggerSamples = 1150085

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        TriggerType = 1250012

        '''''<summary>
        '''''System.String
        '''''</summary>
        TriggerSource = 1250013

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedRefTriggerOutputTerminal = 1150098

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerDelayTime = 1250015

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerHoldoff = 1250016

        '''''<summary>
        '''''System.Double
        '''''</summary>
        StartToRefTriggerHoldoff = 1150103

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerImpedance = 1150075

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerLevel = 1250017

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerHysteresis = 1150006

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        TriggerCoupling = 1250014

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        TriggerSlope = 1250018

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        TriggerModifier = 1250102

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        TriggerAutoTriggered = 1150278

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerWindowLowLevel = 1150013

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerWindowHighLevel = 1150014

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        TriggerWindowMode = 1150012

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        TvTriggerSignalFormat = 1250201

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        TvTriggerLineNumber = 1250206

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        TvTriggerPolarity = 1250204

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        TvTriggerEvent = 1250205

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        EnableDcRestore = 1150093

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        RefTriggerDetectorLocation = 1150314

        '''''<summary>
        '''''System.Double
        '''''</summary>
        RefTriggerMinimumQuietTime = 1150315

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DeviceTemperature = 1150086

        '''''<summary>
        '''''System.String
        '''''</summary>
        SerialNumber = 1150104

        '''''<summary>
        '''''System.String
        '''''</summary>
        InputClockSource = 1150002

        '''''<summary>
        '''''System.String
        '''''</summary>
        OutputClockSource = 1150003

        '''''<summary>
        '''''System.String
        '''''</summary>
        ClockSyncPulseSource = 1150007

        '''''<summary>
        '''''System.String
        '''''</summary>
        SampClkTimebaseSrc = 1150087

        '''''<summary>
        '''''System.Double
        '''''</summary>
        SampClkTimebaseRate = 1150088

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        SampClkTimebaseDiv = 1150089

        '''''<summary>
        '''''System.Double
        '''''</summary>
        RefClkRate = 1150090

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedSampleClockOutputTerminal = 1150091

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        PllLockStatus = 1151303

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        OscillatorPhaseDacValue = 1150105

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        MasterEnable = 1150008

        '''''<summary>
        '''''System.String
        '''''</summary>
        AcqArmSource = 1150053

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedStartTriggerOutputTerminal = 1150097

        '''''<summary>
        '''''System.String
        '''''</summary>
        RecordArmSource = 1150065

        '''''<summary>
        '''''System.String
        '''''</summary>
        AdvTrigSrc = 1150094

        '''''<summary>
        '''''System.String
        '''''</summary>
        ExportedAdvanceTriggerOutputTerminal = 1150109

        '''''<summary>
        '''''System.String
        '''''</summary>
        ReadyForRefEventOutputTerminal = 1150111

        '''''<summary>
        '''''System.String
        '''''</summary>
        ReadyForStartEventOutputTerminal = 1150110

        '''''<summary>
        '''''System.String
        '''''</summary>
        ReadyForAdvanceEventOutputTerminal = 1150112

        '''''<summary>
        '''''System.String
        '''''</summary>
        EndOfRecordEventOutputTerminal = 1150099

        '''''<summary>
        '''''System.String
        '''''</summary>
        EndOfAcquisitionEventOutputTerminal = 1150101

        '''''<summary>
        '''''System.String
        '''''</summary>
        _5vOutOutputTerminal = 1150129

        '''''<summary>
        '''''System.String
        '''''</summary>
        ArmRefTrigSrc = 1150095

        '''''<summary>
        '''''System.Double
        '''''</summary>
        SlaveTriggerDelay = 1150046

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerToStarDelay = 1150047

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerToRtsiDelay = 1150048

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerToPfiDelay = 1150049

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerFromStarDelay = 1150050

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerFromRtsiDelay = 1150051

        '''''<summary>
        '''''System.Double
        '''''</summary>
        TriggerFromPfiDelay = 1150052

        '''''<summary>
        '''''System.String
        '''''</summary>
        MeasOtherChannel = 1150018

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasHysteresisPercent = 1150019

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        MeasLastAcqHistogramSize = 1150020

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasArrayGain = 1150043

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasArrayOffset = 1150044

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasChanLowRefLevel = 1150038

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasChanMidRefLevel = 1150039

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasChanHighRefLevel = 1150040

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        MeasRefLevelUnits = 1150016

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        MeasPercentageMethod = 1150045

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        MeasPolynomialInterpolationOrder = 1150029

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasInterpolationSamplingFactor = 1150030

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        MeasVoltageHistogramSize = 1150021

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasVoltageHistogramLowVolts = 1150022

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasVoltageHistogramHighVolts = 1150023

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        MeasTimeHistogramSize = 1150024

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasTimeHistogramLowVolts = 1150025

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasTimeHistogramHighVolts = 1150026

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasTimeHistogramLowTime = 1150027

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasTimeHistogramHighTime = 1150028

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasFilterCutoffFreq = 1150031

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasFilterCenterFreq = 1150032

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasFilterWidth = 1150041

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasFilterRipple = 1150033

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MeasFilterTransientWaveformPercent = 1150034

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        MeasFilterType = 1150035

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        MeasFilterOrder = 1150036

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        MeasFilterTaps = 1150037

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        MeasFirFilterWindow = 1150042

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DelayBeforeInitiate = 1151304

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        FetchInterleavedData = 1150072

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        EnableDither = 1151300

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcEnable = 1151003

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DdcNcoFrequency = 1151000

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DdcNcoPhase = 1151001

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcTestSineCosine = 1151072

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcCoordinateConverterInput = 1151073

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcQInputToCoordConverterInput = 1151074

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcSyncoutClkSelect = 1151080

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcTimingNcoPhaseAccumLoad = 1151120

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcTimingNcoClearPhaseAccum = 1151121

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcTimingNcoEnableOffsetFreq = 1151122

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcTimingNcoNumOffsetFreqBits = 1151123

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcTimingNcoCenterFrequency = 1151124

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcTimingNcoPhaseOffset = 1151125

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcResamplerFilterModeSelect = 1151126

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcResamplerBypass = 1151127

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcResamplerOutputPulseDelay = 1151128

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcNcoDivide = 1151129

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcReferenceDivide = 1151130

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcCicDecimation = 1151010

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcCicShiftGain = 1151011

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcDiscriminatorEnabled = 1151020

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcDiscriminatorFirDecimation = 1151021

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcDiscriminatorFirSymmetry = 1151022

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcDiscriminatorFirSymmetryType = 1151023

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcDiscriminatorFirNumTaps = 1151024

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcDiscriminatorDelay = 1151025

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcDiscriminatorFirInputSource = 1151026

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcDiscriminatorPhaseMultiplier = 1151027

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcPfirDecimation = 1151030

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcPfirSymmetry = 1151031

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcPfirSymmetryType = 1151032

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcPfirNumTaps = 1151033

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcPfirRealOrComplex = 1151034

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DdcAgcUpperGainLimit = 1151040

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DdcAgcLowerGainLimit = 1151041

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcAgcLoopGain0Exponent = 1151042

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcAgcLoopGain0Mantissa = 1151043

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcAgcLoopGain1Exponent = 1151044

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcAgcLoopGain1Mantissa = 1151045

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcAgcThreshold = 1151046

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcAgcAverageControl = 1151047

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcHalfbandBypassed = 1151050

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcHalfband1Enabled = 1151051

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcHalfband2Enabled = 1151052

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcHalfband3Enabled = 1151053

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcHalfband4Enabled = 1151054

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcHalfband5Enabled = 1151055

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcAoutParallelOutputSource = 1151070

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcBoutParallelOutputSource = 1151071

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcCombinedDecimation = 1151301

        '''''<summary>
        '''''System.Double
        '''''</summary>
        SerialDacCalVoltage = 1151302

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MaxRisRate = 1150074

        '''''<summary>
        '''''System.Double
        '''''</summary>
        MaxRealTimeSamplingRate = 1150073

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        OnboardMemorySize = 1150069

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        RangeCheck = 1050002

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        QueryInstrumentStatus = 1050003

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        Cache = 1050004

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        Simulate = 1050005

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        RecordCoercions = 1050006

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        InterchangeCheck = 1050021

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverDescription = 1050514

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverPrefix = 1050302

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverVendor = 1050513

        '''''<summary>
        '''''System.String
        '''''</summary>
        SpecificDriverRevision = 1050551

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        SpecificDriverClassSpecMajorVersion = 1050515

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        SpecificDriverClassSpecMinorVersion = 1050516

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        ChannelCount = 1050203

        '''''<summary>
        '''''System.String
        '''''</summary>
        SupportedInstrumentModels = 1050327

        '''''<summary>
        '''''System.String
        '''''</summary>
        GroupCapabilities = 1050401

        '''''<summary>
        '''''System.String
        '''''</summary>
        InstrumentManufacturer = 1050511

        '''''<summary>
        '''''System.String
        '''''</summary>
        InstrumentModel = 1050512

        '''''<summary>
        '''''System.String
        '''''</summary>
        InstrumentFirmwareRevision = 1050510

        '''''<summary>
        '''''System.String
        '''''</summary>
        IoResourceDescriptor = 1050304

        '''''<summary>
        '''''System.String
        '''''</summary>
        LogicalName = 1050305

        '''''<summary>
        '''''System.String
        '''''</summary>
        DriverSetup = 1050007

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcEnabled = 1150300

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DdcDataProcessingMode = 1150304

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        FetchInterleavedIqData = 1150311

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DdcFrequencyTranslationEnabled = 1150302

        '''''<summary>
        '''''System.String
        '''''</summary>
        DdcQSource = 1150310

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DdcCenterFrequency = 1150303

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DdcFrequencyTranslationPhaseI = 1150305

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DdcFrequencyTranslationPhaseQ = 1150306

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        EqualizationNumCoefficients = 1150312

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        EqualizationFilterEnabled = 1150313

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        OverflowErrorReporting = 1150309

        '''''<summary>
        '''''System.String
        '''''</summary>
        FiveVoltOutputTerminal = 1150129

        '''''<summary>
        '''''System.Boolean
        '''''</summary>        
        EnableBandpassFilter = 1150318

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        DitherEnable = 1150319

        '''''<summary>
        '''''System.Boolean
        '''''</summary>
        EnableFractionalResample = 1150320

        '''''<summary>
        '''''System.Double
        '''''</summary>
        DataTransferMaximumBandwidth = 1150321

        '''''<summary>
        '''''System.Int32
        '''''</summary>
        DataTransferPreferredPacketSize = 1150322
    End Enum
End Namespace